/*
basic concepts used in the segmentation experiment
*/
import java.util.Hashtable;
import java.io.*;
import java.lang.*;
//#############################################################
class basicConcepts
{
    /*
    tokens representing
    words: 7
    W: parent class of U L A S D H
    U: starts with A to Z, followed by a to z and A to Z. e.g. John
    L: starts with a to z, followed by a to z and A to Z. e.g. class
    A: words having only 2 or more A to Z capital letters. e.g. NBA
    S: single capital letter from A to Z
    D: starts with a 0 to 9 number, having a to z or A to Z letter in body. e.g. 128MB, 80k
    H: starts with a a to z or A to Z letter, having number in body. e.g. mp3, H20
    Q: A.
    W: a.
    
    tags:1
    T: tags, starts with <, ends with >, having A to Z letter in between. e.g. <BR>
    
    numbers: 7
    N: parent class of 0 to 5
    1/2/3/4/5: a number with a length of 1/2/3/4/5. e.g 1
    0: a number with a length longer than 5
    
    B:<REC>
    E:</REC>
    punctuation tokens: 32
    as themselves ~`!@#$%^&*()_-+={[}]|\:;"'<,>.?/
    #######################################
    <TI>: article/book title
    <VO>: volume/issue/no
    <PP>: page
    <GL>: geographic location
    <OR>: organization    
    <DA>: date, month/year
    <PU>: publisher    
    <JN>: journal/conference, also lecture notes.
    <AU>: author
    <ED>: editor mark (editors, editor, eds, ed)
    <FL>: file type (pdf, ps, doc, ppt, postScript), also abstracts,
    <LK>: URL
    <NG>: other irrelative information
    <DE>: delimiter between segments
    */
   
    //public static String WtokenSet = " WU WL WA WS WD WH TT N1 N2 N3 N4 N5 N0 Px";
    public static String set1 = " U L A S D H T 0 1 2 3 4 5 ";
    public static String set2 = "~`!@#$%^&*()_-+={[}]|\\:;\"'<,>.?/";
    public static int T_SIZE = 49; //6 + 1 + 6 + 32 + 2 + Q: X. W: x.
    public static int P_SIZE = 31;
    public static int C_SIZE = 12;
    /*
      F_SIZE
    avg/min/max/sd length in words
    avg/min/max/sd length in letters
    s_token, body_token, e_token, token_doublets
    s_pos, body_pos, e_pos, pos_doublets
    
    */
    public static int F_SIZE = (P_SIZE + T_SIZE) + T_SIZE * T_SIZE + P_SIZE * P_SIZE; //3442
    public static char[] tokenDic;
    public Hashtable tokenHash, posHash, tagHash;
    public static String[] posDic, csTag;
    private String hasStr;
    private int yy;
    private char ch, startCh, endCh; 
    
    public basicConcepts ()
    {
	tokenDic = new char[T_SIZE];
	tokenDic[0] = 'U'; tokenDic[1] = 'L'; tokenDic[2] = 'A'; tokenDic[3] = 'S'; tokenDic[4] = 'D'; 
	tokenDic[5] = 'H'; tokenDic[6] = 'T'; tokenDic[7] = '0'; tokenDic[8] = '1'; tokenDic[9] = '2';
	tokenDic[10] = '3'; tokenDic[11] = '4'; tokenDic[12] = '5'; tokenDic[13] = '~'; tokenDic[14] = '`';
	tokenDic[15] = '!'; tokenDic[16] = '@'; tokenDic[17] = '#'; tokenDic[18] = '$'; tokenDic[19] = '%';
	tokenDic[20] = '^'; tokenDic[21] = '&'; tokenDic[22] = '*'; tokenDic[23] = '('; tokenDic[24] = ')';
	tokenDic[25] = '-'; tokenDic[26] = '_'; tokenDic[27] = '+'; tokenDic[28] = '='; tokenDic[29] = '|';
	tokenDic[30] = '\\'; tokenDic[31] = '{'; tokenDic[32] = '['; tokenDic[33] = '}'; tokenDic[34] = ']';
	tokenDic[35] = ':'; tokenDic[36] = ';'; tokenDic[37] = '"'; tokenDic[38] = '\''; tokenDic[39] = '<';
	tokenDic[40] = ','; tokenDic[41] = '>'; tokenDic[42] = '.'; tokenDic[43] = '?'; tokenDic[44] = '/';
	tokenDic[45] = 'B'; tokenDic[46] = 'E'; tokenDic[47] = 'Q'; tokenDic[48] = 'W';
	
	tokenHash = new Hashtable(T_SIZE);
	tokenHash.put("U",new Integer(0)); tokenHash.put("L",new Integer(1)); tokenHash.put("A",new Integer(2));
	tokenHash.put("S",new Integer(3)); tokenHash.put("D",new Integer(4)); tokenHash.put("H",new Integer(5));
	tokenHash.put("T",new Integer(6)); tokenHash.put("0",new Integer(7)); tokenHash.put("1",new Integer(8));
	tokenHash.put("2",new Integer(9)); tokenHash.put("3",new Integer(10)); tokenHash.put("4",new Integer(11));
	tokenHash.put("5",new Integer(12)); tokenHash.put("~",new Integer(13)); tokenHash.put("`",new Integer(14));
	tokenHash.put("!",new Integer(15)); tokenHash.put("@",new Integer(16)); tokenHash.put("#",new Integer(17));
	tokenHash.put("$",new Integer(18)); tokenHash.put("%",new Integer(29)); tokenHash.put("^",new Integer(20));
	tokenHash.put("&",new Integer(21)); tokenHash.put("*",new Integer(22)); tokenHash.put("(",new Integer(23));
	tokenHash.put(")",new Integer(24)); tokenHash.put("-",new Integer(25)); tokenHash.put("_",new Integer(26));
	tokenHash.put("+",new Integer(27)); tokenHash.put("=",new Integer(28)); tokenHash.put("|",new Integer(29));
	tokenHash.put("\\",new Integer(30)); tokenHash.put("{",new Integer(31)); tokenHash.put("[",new Integer(32));
	tokenHash.put("}",new Integer(33)); tokenHash.put("]",new Integer(34)); tokenHash.put(":",new Integer(35));
	tokenHash.put(";",new Integer(36)); tokenHash.put("\"",new Integer(37)); tokenHash.put("'",new Integer(38));
	tokenHash.put("<",new Integer(39)); tokenHash.put(",",new Integer(40)); tokenHash.put(">",new Integer(41));
	tokenHash.put(".",new Integer(42)); tokenHash.put("?",new Integer(43)); tokenHash.put("/",new Integer(44)); 
	tokenHash.put("B",new Integer(45)); tokenHash.put("E",new Integer(46)); 
	tokenHash.put("Q",new Integer(47)); tokenHash.put("W",new Integer(48)); 
	
	posDic = new String[P_SIZE];
	posDic[0] = "CC"; posDic[1] = "CD"; posDic[2] = "DT"; posDic[3] = "EX"; posDic[4] = "FW";
	posDic[5] = "IN"; posDic[6] = "JJ"; posDic[7] = "LS"; posDic[8] = "MD"; posDic[9] = "NN";
	posDic[10] = "PD"; posDic[11] = "PO"; posDic[12] = "PR"; posDic[13] = "RB"; posDic[14] = "RP";
	posDic[15] = "TO"; posDic[16] = "UH"; posDic[17] = "VB"; posDic[18] = "W"; posDic[19] = "SY";
	posDic[20] = "#"; posDic[21] = "$"; posDic[22] = "."; posDic[23] = ","; posDic[24] = ":";
	posDic[25] = "("; posDic[26] = ")"; posDic[27] = "\""; posDic[28] = "'"; posDic[29] = "``";
	posDic[30] = "''";
	
	posHash = new Hashtable(P_SIZE);
	posHash.put("CC",new Integer(0)); posHash.put("CD",new Integer(1)); posHash.put("DT",new Integer(2));
	posHash.put("EX",new Integer(3)); posHash.put("FW",new Integer(4)); posHash.put("IN",new Integer(5));
	posHash.put("JJ",new Integer(6)); posHash.put("LS",new Integer(7)); posHash.put("MD",new Integer(8));
	posHash.put("NN",new Integer(9)); posHash.put("PD",new Integer(10)); posHash.put("PO",new Integer(11));
	posHash.put("PR",new Integer(12)); posHash.put("RB",new Integer(13)); posHash.put("RP",new Integer(14));
	posHash.put("TO",new Integer(15)); posHash.put("UH",new Integer(16)); posHash.put("VB",new Integer(17));
	posHash.put("W",new Integer(18)); posHash.put("SY",new Integer(19)); posHash.put("#",new Integer(20));
	posHash.put("$",new Integer(21)); posHash.put(".",new Integer(22)); posHash.put(",",new Integer(23));
	posHash.put(":",new Integer(24)); posHash.put("(",new Integer(25)); posHash.put(")",new Integer(26));
	posHash.put("\"",new Integer(27)); posHash.put("'",new Integer(28)); posHash.put("``", new Integer(29));
	posHash.put("''", new Integer(30));
	
	csTag = new String[C_SIZE];
	csTag[0] = "<TI>"; csTag[1] = "<VO>"; csTag[2] = "<PP>"; csTag[3] = "<GL>"; csTag[4] = "<OR>";
	csTag[5] = "<DA>"; csTag[6] = "<PU>"; csTag[7] = "<JN>"; csTag[8] = "<AU>";
	csTag[9] = "<FL>"; csTag[10] = "<NG>"; csTag[11] = "<DE>";
	
	tagHash = new Hashtable();
	tagHash.put("<TI>", new Integer(0)); tagHash.put("<VO>", new Integer(1)); tagHash.put("<PP>", new Integer(2)); 
	tagHash.put("<GL>", new Integer(3)); tagHash.put("<OR>", new Integer(4)); tagHash.put("<DA>", new Integer(5));
	tagHash.put("<PU>", new Integer(6)); tagHash.put("<JN>", new Integer(7)); tagHash.put("<AU>", new Integer(8)); 
	tagHash.put("<FL>", new Integer(9)); tagHash.put("<NG>", new Integer(10)); tagHash.put("<DE>", new Integer(11)); 
	/*
	for(yy=0;yy<T_SIZE;yy++) {System.out.println("tokenDic["+yy+"]="+tokenDic[yy]);}
	System.out.println("\ntokenHash[]="+tokenHash.toString());
	for(yy=0;yy<P_SIZE;yy++) {System.out.println("posDic["+yy+"]="+posDic[yy]);}
	System.out.println("\nposHash[]="+posHash.toString());
	for(yy=0;yy<C_SIZE;yy++) {System.out.println("category["+yy+"]="+csTag[yy]);}
	System.out.println("\ntagHash[]="+tagHash.toString());
	*/
    }
    //given a text string without white space, it returns token type symbols
    //" WU WL WA WS WN WH TG N1 N2 N3 N4 N5 N0 ",  "~`!@#$%^&*()_-+={[}]|\\:;\"'<,>.?/";
    public char getTokenType(String arg)
    {
	if (arg.equals("<RS>")) {return 'B';}
	if (arg.equals("<RE>")) {return 'E';}
	
	if (arg.equals("'s") || arg.equals("'re") || arg.equals("'m") || arg.equals("'ve") || arg.equals("'d") || arg.equals("'ll")) {return 'L';}
	
	if (arg.length()==2) {
		startCh = arg.charAt(0);
		endCh = arg.charAt(1);
		if (startCh>='A' && startCh<='Z' && endCh=='.') {return 'Q';}
		else if (startCh>='a' && startCh<='z' && endCh=='.') {return 'W';}
	}//if length==2
    	
    	ch = arg.charAt(0);
    	if (ch>='A' && ch<='Z') {startCh = 'U';}
    	else if (ch>='a' && ch<='z') {startCh = 'L';}
    	else if (ch>='0' && ch<='9') {startCh = 'D';}
    	else {startCh = ch;}
    	
    	if (arg.length()==1) {
    	    if (startCh=='U') {return 'S';}
	    else if (startCh=='D') {return '1';}
	    else if (startCh=='L') {return 'L';}
    	    else {return startCh;}
    	}
    	
    	hasStr = "";
    	for(yy=1;yy<arg.length();yy++) {
	    ch = arg.charAt(yy);
	    if (ch>='A' && ch<='Z' && hasStr.indexOf("U")<0) {hasStr += "U";}
    	    else if (ch>='a' && ch<='z' && hasStr.indexOf("L")<0) {hasStr += "L";}
    	    else if (ch>='0' && ch<='9' && hasStr.indexOf("D")<0) {hasStr += "D";}
    	    else if (!Character.isLetterOrDigit(ch) && hasStr.indexOf(String.valueOf(ch))<0) {hasStr += String.valueOf(ch);}
	}
	//System.out.println("hasStr="+hasStr);
	if (startCh=='U' && hasStr.equals("U")) {return 'A';}
	else if (startCh=='U' && (hasStr.equals("L") || hasStr.equals("UL") || hasStr.equals("LU"))) {return 'U';}
	else if (startCh=='L' && (hasStr.equals("L") || hasStr.equals("U") || hasStr.equals("UL") || hasStr.equals("LU"))) {return 'L';}
    	else if ((startCh=='L' || startCh=='U') && hasStr.indexOf("D")>-1) {return 'H';}
    	else if (startCh=='D' && (hasStr.indexOf("L")>-1 || hasStr.indexOf("U")>-1)) {return 'D';}
    	else if (startCh=='D' && hasStr.equals("D")) {
	    yy = arg.length();
	    if (yy<=5) {return String.valueOf(yy).charAt(0);}
	    else {return '0';}
	}
    	
    	ch = arg.charAt(arg.length()-1);
    	if (ch>='A' && ch<='Z') {endCh = 'U';}
    	else if (ch>='a' && ch<='z') {endCh = 'L';}
    	else if (ch>='0' && ch<='9') {endCh = 'D';}
    	else {endCh = ch;}
    	
	//if (startCh=='<' && endCh=='>' && (hasStr.equals("U>") || hasStr.equals("LU>") || hasStr.equals("UL>") || hasStr.equals("L>") || hasStr.equals("/U>") || hasStr.equals("/LU>") || hasStr.equals("/UL>") || hasStr.equals("/L>"))) {return 'T';}
	if (startCh=='<' && endCh=='>' && hasStr.indexOf(" ")<0 && hasStr.length()>1) {return 'T';}
	else {return startCh;}
    }
    //#################################################

    public static void main(String[] args)
    {
	String asdf;
	int xxx;
	basicConcepts bt = new basicConcepts();
	try {
	    while (1>0) {
		asdf = "";
		
		while ((xxx = System.in.read())!=10) {
			//System.out.println(xxx);
		    asdf += String.valueOf((char)xxx);
		}
		asdf = asdf.substring(0,asdf.length());
		System.out.println("_"+asdf+"_");
		System.out.println(bt.getTokenType(asdf)+"\n--------");
	    }
	}catch (java.lang.Exception e) {System.out.println(e.toString());}
	//System.out.println("-----------\n"+bt.getTokenType(args[0])+"\n------------");
	
	return;
    }//main

}
