/*
n data sets, test 1 set by using training data from other (n-1) sets
java segpTrain set_asdf
-----------------------------------------------------------------
4.body tokens 57 - 105
7.body POSs 186 - 216
9.token doublets 248 - 2648 (49 * 49 = 2401 cells)
10.POS doublets 2649 - 3609 (31 * 31 = 961)
11.actual words list
13.keywords list (only available for certain categories)

given a directory, set_felten_1
find file set_felten_1_training
read one line from file
get features

T_SIZE = 49; //6 + 1 + 6 + 32 + 2 + 1  +  1
				    Q:X.  W:x.
P_SIZE = 31;
C_SIZE = 16; including RS,RE, no AW
F_SIZE = 3442

write to output file
*/

import java.lang.*;
import java.io.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Date;
import montytagger.JMontyTagger;
//##########################
class segpTrain
{ 
    private basicConcepts bc;
    private montytagger.JMontyTagger jmt;
    
    //tmdet[t1][t2][m][cat], tmt[t1][t2][t][cat], cmdec[c1][c2][m][cat]
    private int[][][][] tmdet, tmt, cmdec;
    private int[] countC;
    private int[][] deCntInCat;
    private Vector[] wrd, wrdC, tkn, tknC, pos, posC, ww, wwC, tt, ttC, pp, ppC;
    private int[] recCount;
    private String[] words1, words2, tmpWords, dataStr, fileNames;
    private int C_INDEX,  leftTid, rightTid, catid, iii,jjj,fff,ggg, bbb, aaa;
    private int STARTSET, ENDSET, TOTALUNIQUEWORDS;
    private int kk, yy,zz, mm,  nn;
    private char tokenType, nextTokenType;
    private String line, argTrainingDirName, argAbsDirName, fileStr1;
    private String trainStr, label, tmp1, tmp2, tmp3, tmp4, tmp5, tmp10, tmp11;
    private File F1,F2, F3;
    private RandomAccessFile file1,file2, file3;
    private boolean found1;
    private Vector wordList,  deV, deCntV, cmmc, cmmcCnt, tmmt, tmmtCnt;
    private Hashtable deHash;
    private Date sDate, eDate;
    
    private filesFromDir ffd;
    //####################
    public segpTrain(String arg, String argStartID, String argEndID)
    {
	argTrainingDirName = arg;
	bc = new basicConcepts();
	deV = new Vector(); 
		
	try {STARTSET = Integer.parseInt(argStartID); ENDSET = Integer.parseInt(argEndID);}
	catch  (java.lang.Exception e) {System.out.println(e.toString()+"..startsetid"); STARTSET=0; ENDSET = 0;}
	//-------------------
	jmt = new montytagger.JMontyTagger();
		
	countC = new int[bc.C_SIZE];
		
	deCntV = new Vector();
	
	wrd = new Vector[bc.C_SIZE]; wrdC = new Vector[bc.C_SIZE];
	tkn = new Vector[bc.C_SIZE]; tknC = new Vector[bc.C_SIZE];
	pos = new Vector[bc.C_SIZE]; posC = new Vector[bc.C_SIZE];
	ww = new Vector[bc.C_SIZE]; wwC = new Vector[bc.C_SIZE];
	tt = new Vector[bc.C_SIZE]; ttC = new Vector[bc.C_SIZE];
	pp = new Vector[bc.C_SIZE]; ppC = new Vector[bc.C_SIZE];
	   
	//wrd, wrdC, tkn, tknC, pos, posC, wp, wpC, tp, tpC, pp, ppC,
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    wrd[iii] = new Vector(); wrdC[iii] = new Vector();
	    tkn[iii] = new Vector(); tknC[iii] = new Vector();
	    pos[iii] = new Vector(); posC[iii] = new Vector();
	    ww[iii] = new Vector(); wwC[iii] = new Vector();
	    tt[iii] = new Vector(); ttC[iii] = new Vector();
	    pp[iii] = new Vector(); ppC[iii] = new Vector();
	}
	wordList = new Vector();
	
	deHash = new Hashtable();
	cmmc = new Vector(); cmmcCnt = new Vector();
	tmmt = new Vector(); tmmtCnt = new Vector();
    }
    //######################
    //for each String, remove all tags, punctuation
    private String tmp9;
    private String removeTagPunc(String arg)
    {
    	tmp9 = arg;
    	tmp9 = tmp9.replaceAll("</[\\S]+>"," ");
    	tmp9 = tmp9.replaceAll("<[\\S]+>"," ");
    	tmp9 = tmp9.replaceAll("[^\\w ]+"," ");
    	while(tmp9.indexOf("  ")>-1) {tmp9 = tmp9.replaceAll("  ", " ");}
    	return tmp9.trim();    	
    }
    //####################
    //fill countC, wrd, wrdC, tkn, tknC, pos, posC, wp, wpC, tp, tpC, pp, ppC;
    //deV, deCntV
    private char ch1;
    private void getFeatures(String arg, String argLabel) //(pure data, <tag>
    {
	//System.out.println(arg);
	if (arg.equals("") || arg==null) {System.out.println(arg+" "+argLabel+"))))))))))))))"); return;}

	if (!bc.tagHash.containsKey(argLabel)) {System.out.println(arg+" "+argLabel+"))))))))))))))"); return;}
	else {C_INDEX = Integer.parseInt(String.valueOf(bc.tagHash.get(argLabel)));}
	
	words1 = arg.trim().split(" ");
	if (words1.length<=0) {System.out.println(arg+" "+argLabel+"))))))))))))))"); return;}
	
	countC[C_INDEX] += words1.length;
	
	//collecting delimiters
	if (argLabel.equals("<DE>")) {
	    for(zz=0;zz<words1.length;zz++) {
	    	found1 = false;
	    	for(kk=0;kk<deV.size();kk++) {
	    	    if (words1[zz].equals(String.valueOf(deV.elementAt(kk)))) {
	    	        deCntV.set(kk,String.valueOf(Integer.parseInt(String.valueOf(deCntV.elementAt(kk)))+1));
	    	    	found1 = true;
	    	    	break;
	    	    }
	    	}//for kk
	    	if (!found1) {deV.add(words1[zz]); deCntV.add("1");}
	    }//for zz
	} // if <DE>

	//token, word
	for(zz=0;zz<words1.length;zz++) {
	    //token
	    tokenType = bc.getTokenType(words1[zz]);
	    tmp1 = String.valueOf(bc.tokenHash.get(String.valueOf(tokenType))); //tkn id
	    found1 = false;
	    for(kk=0;kk<tkn[C_INDEX].size();kk++) {
		tmp2 = String.valueOf(tkn[C_INDEX].elementAt(kk)); //tkn id
		if (tmp1.equals(tmp2)) {
		    found1 = true;
		    tknC[C_INDEX].set(kk,String.valueOf(Integer.parseInt(String.valueOf(tknC[C_INDEX].elementAt(kk)))+1));
		    break;
		}
	    }//for kk
	    if (!found1) {tkn[C_INDEX].add(tmp1); tknC[C_INDEX].add("1");}
	    	    
	    //token pairs
	    if (zz<(words1.length-1)) {
		nextTokenType = bc.getTokenType(words1[zz+1]);
		tmp3 = tmp1+" "+String.valueOf(bc.tokenHash.get(String.valueOf(nextTokenType))); //t1 id, t2 id
		found1 = false;
		for(kk=0;kk<tt[C_INDEX].size();kk++) {
		    tmp2 = String.valueOf(tt[C_INDEX].elementAt(kk)); //t1 id, t2 id
		    if (tmp3.equals(tmp2)) {
			found1 = true;
			ttC[C_INDEX].set(kk,String.valueOf(Integer.parseInt(String.valueOf(ttC[C_INDEX].elementAt(kk)))+1));
			break;
		    }
		}//for kk
		if (!found1) {tt[C_INDEX].add(tmp3); ttC[C_INDEX].add("1");}
	    }
	    
	    //word
	    tmp1 = words1[zz].toLowerCase();
	    found1 = false;
	    for(kk=0;kk<wrd[C_INDEX].size();kk++) {
		tmp2 = String.valueOf(wrd[C_INDEX].elementAt(kk)); //tkn id
		if (tmp1.equals(tmp2)) {
		    found1 = true;
		    wrdC[C_INDEX].set(kk,String.valueOf(Integer.parseInt(String.valueOf(wrdC[C_INDEX].elementAt(kk)))+1));
		    break;
		}
	    }//for kk
	    if (!found1) {wrd[C_INDEX].add(tmp1); wrdC[C_INDEX].add("1");}
	    	    
	    //word pairs
	    if (zz<(words1.length-1)) {
		tmp3 = tmp1+" "+words1[zz+1].toLowerCase();
		found1 = false;
		for(kk=0;kk<ww[C_INDEX].size();kk++) {
		    tmp2 = String.valueOf(ww[C_INDEX].elementAt(kk)); //tkn id
		    if (tmp3.equals(tmp2)) {
			found1 = true;
			wwC[C_INDEX].set(kk,String.valueOf(Integer.parseInt(String.valueOf(wwC[C_INDEX].elementAt(kk)))+1));
			break;
		    }
		}//for kk
		if (!found1) {ww[C_INDEX].add(tmp3); wwC[C_INDEX].add("1");}
	    }
	}//for zz
	
	//pos, pos pairs
	//##############
	words1 = arg.toLowerCase().split(" ");
	tmp3 = "";
	for(zz=0;zz<words1.length;zz++) {
	    if (words1[zz].length()>1) {
		ch1 = words1[zz].charAt(words1[zz].length()-1);
		while (words1[zz].length()>1 && !Character.isLetterOrDigit(ch1)) {
		    words1[zz] = words1[zz].substring(0,words1[zz].length()-1);
		    ch1 = words1[zz].charAt(words1[zz].length()-1);
		}
	    }
	    tmp3 += words1[zz]+" ";
	}//for zz
	tmp3 = tmp3.trim();
	tmp3 = jmt.Tag(tmp3);
	//#################
	
	//tmp3 = jmt.Tag(arg.toLowerCase()).trim(); //System.out.println("\n--------------\n"+tmp3);
	
	words1 = tmp3.split(" ");
	for(zz=0;zz<words1.length;zz++) {
	    kk = words1[zz].lastIndexOf("/");
	    if (kk<0) {continue;}
	    tmp1 = words1[zz].substring(kk+1);//POS tag
	    if (tmp1.length()>2) {tmp1 = tmp1.substring(0,2);}
	    if (tmp1.startsWith("W")) {tmp1 = tmp1.substring(0,1);}
	    tmp1 = String.valueOf(bc.posHash.get(String.valueOf(tmp1)));//pos id
	    found1 = false;
	    for(kk=0;kk<pos[C_INDEX].size();kk++) {
		tmp2 = String.valueOf(pos[C_INDEX].elementAt(kk)); //pos id
		if (tmp1.equals(tmp2)) {
		    found1 = true;
		    posC[C_INDEX].set(kk,String.valueOf(Integer.parseInt(String.valueOf(posC[C_INDEX].elementAt(kk)))+1));
		    break;
		}
	    }//for kk
	    if (!found1) {pos[C_INDEX].add(tmp1); posC[C_INDEX].add("1");}
	    	    
	    //token pairs
	    if (zz<(words1.length-1)) {
		//System.out.println(words1[zz]+" "+words1[zz+1]);
		kk = words1[zz+1].lastIndexOf("/");
		if (kk<0) {continue;}
		tmp3 = words1[zz+1].substring(kk+1);//POS tag
		if (tmp3.length()>2) {tmp3 = tmp3.substring(0,2);}
		if (tmp3.startsWith("W")) {tmp3 = tmp3.substring(0,1);}
		tmp3 = String.valueOf(bc.posHash.get(String.valueOf(tmp3)));//pos id
		tmp3 = tmp1+" "+tmp3; //p1 id, p2 id
		found1 = false;
		for(kk=0;kk<pp[C_INDEX].size();kk++) {
		    tmp2 = String.valueOf(pp[C_INDEX].elementAt(kk)); //p1 id, p2 id
		    if (tmp3.equals(tmp2)) {
			found1 = true;
			ppC[C_INDEX].set(kk,String.valueOf(Integer.parseInt(String.valueOf(ppC[C_INDEX].elementAt(kk)))+1));
			break;
		    }
		}//for kk
		if (!found1) {pp[C_INDEX].add(tmp3); ppC[C_INDEX].add("1");}
	    }
	}//for zz
	
	return;
    }
    //####################
    private void runTenFolder() 
    {
	int hhh, runff,rungg, uuu;
	sDate = new java.util.Date();

	try {
	    ffd = new filesFromDir();
	    ffd.set(argTrainingDirName,"_addTail");
	    if (ffd.findFiles() && ffd.fileList.size()>0) {
		//STARTSET = 0; ENDSET = ffd.fileList.size();
		F1 = new File(String.valueOf(ffd.fileList.elementAt(0)));
		argAbsDirName = F1.getPath();
		argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("/"));
		//argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("\\"));
		
		dataStr = new String[ffd.fileList.size()];
		recCount = new int[ffd.fileList.size()];
		fileNames = new String[ffd.fileList.size()];
		
		for(runff=0;runff<ffd.fileList.size();runff++) {
		    F1 = new File(String.valueOf(ffd.fileList.elementAt(runff)));
		    file1 = new RandomAccessFile(F1,"r");
		    		    
		    fileNames[runff] = F1.getPath(); 
		    fileNames[runff] = fileNames[runff].substring(fileNames[runff].lastIndexOf("/")+1);
		    //fileNames[runff] = fileNames[runff].substring(fileNames[runff].lastIndexOf("\\")+1);
		    fileNames[runff] = fileNames[runff].substring(fileNames[runff].indexOf("clean_")+6, fileNames[runff].indexOf("_labeled"));
		    recCount[runff] = 0; //# of rec <REC>
		    dataStr[runff] = "";
		    
		    tmp3 = "";//<DE> mark line
		    while ((line=file1.readLine())!=null) {
			if (!line.startsWith("<")) {continue;}
			line = line.trim();
			
			if (!line.equals("<REC>") && !line.equals("</REC>")) {
			    iii = line.indexOf(" ");
			    tmp2 = line.substring(0,iii); //<DE>
			    //record consecutive <DE>s
			    if (tmp2.equals("<DE>")) {tmp3 += line.substring(iii, line.lastIndexOf(" "));}
			    //put <DE>s into dataStr[]
			    else { 
				if (!tmp3.equals("")) {
				    tmp3 = tmp3.trim();
				    while (tmp3.indexOf("  ")>-1) {tmp3 = tmp3.replaceAll("  "," ");}
				    tmp3 = "<DE> "+tmp3+" </DE>";
				    dataStr[runff] += "___"+tmp3;
				}
				tmp3 = "";
				dataStr[runff] += "___" + line;
			    }
			}
			else if (line.equals("<REC>")) {
			    tmp3 = "";
			    dataStr[runff] += "___" + line;
			    recCount[runff]++;
			}
			else {//</REC>
			    if (!tmp3.equals("")) {
				tmp3 = tmp3.trim();
				while (tmp3.indexOf("  ")>-1) {tmp3 = tmp3.replaceAll("  "," ");}
				tmp3 = "<DE> "+tmp3+" </DE>";
				dataStr[runff] += "___"+tmp3;
				tmp3 = "";
			    }
			    dataStr[runff] += "___" + line;
			}
		    }
		    file1.close();
		    System.out.println(recCount[runff] +" Records in " + fileNames[runff]);
		}//for runff
	    } //if ffd
	    else {dataStr = null;}
	}
	catch (java.lang.Exception e) {System.out.println(e.toString());}
	
	//for(runff=0;runff<ffd.fileList.size();runff++) {System.out.println(dataStr[runff].length());}

	for(runff=STARTSET;runff<=ENDSET;runff++) { 
	    trainStr = ""; uuu = 0;
	    for(rungg=0;rungg<ffd.fileList.size();rungg++) {
	    	if (rungg!=runff) {trainStr += dataStr[rungg]; uuu += recCount[rungg];} 
	    }
	    
	    System.out.println(runff+". training "+fileNames[runff]+ ": training_set:"+uuu);
	    
	    trainStr = trainStr.substring(3);
	    tmpWords = trainStr.split("___");
	    //for(rungg=0;rungg<tmpWords.length;rungg++) {System.out.println(tmpWords[rungg]);}
	    //System.out.println(runff+": training set:"+tmpWords.length+" testing set:"+testStr.split("___").length);
	    System.out.println("readData()");
	    readData();
	    System.out.println("countDelimiter()");
	    countDelimiter(); //training 
	    System.out.println("writeTrainingData()");
	    writeTrainingData(runff);
	}//for runff
	
	eDate = new java.util.Date();
	System.out.println(((eDate.getTime()-sDate.getTime())/1000/60)+"minutes");
	return;
    }
    //###########################################
    //get features from every record, save to _features file
    //tf[][], df[][], actualWords[], countC[], deV, deCntV, cw[], cwTF[], cwDF[]
    private void readData()
    {
	deV.clear(); deCntV.clear();
	wordList.clear();
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    countC[iii] = 0;
	    wrd[iii].clear(); wrdC[iii].clear();
	    tkn[iii].clear(); tknC[iii].clear();
	    pos[iii].clear(); posC[iii].clear();
	    ww[iii].clear(); wwC[iii].clear();
	    tt[iii].clear(); ttC[iii].clear();
	    pp[iii].clear(); ppC[iii].clear();
	}
	//System.out.println("tmpWords.length="+tmpWords.length);
	for(fff=0;fff<tmpWords.length;fff++) {
	    line = tmpWords[fff].trim();
	    //System.out.println(fff+" "+line+"\n*************************\n");
	    if (line.equals("<REC>")|| line.equals("</REC>")) {continue;}
		
	    iii = line.indexOf(" ");
	    jjj = line.lastIndexOf(" ");
	    
	    if (!(0<iii && iii<jjj)) {System.out.println(line+" __))))))))))))))"); continue;}
	    label = line.substring(0,iii); //<AU>
	    line = line.substring(iii+1,jjj).trim(); // ... of <au> ... </au>
	    
	    while (line.indexOf("  ")>-1) {line = line.replaceAll("  "," ");}
	    line = line.trim();
	    getFeatures(line, label);//pure data, label;
	}//for fff

	return;
    }
    //####################################
    //deCntInCat(), deHash, tmdet, tmt, cmdec
    private void countDelimiter()
    {
	deHash.clear();
	for(jjj=0;jjj<deV.size();jjj++) {deHash.put(String.valueOf(deV.elementAt(jjj)),String.valueOf(jjj));}
	
	deCntInCat = new int[bc.C_SIZE][deV.size()];
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    for(jjj=0;jjj<deV.size();jjj++) {deCntInCat[iii][jjj] = 0;}
        }
    		
        for(fff=0;fff<tmpWords.length;fff++) {
            line = tmpWords[fff].trim();
            iii = line.indexOf(" ");
	    jjj = line.lastIndexOf(" ");
		
            if (!(0<iii && iii<jjj)) {continue;}
	    label = line.substring(0,iii); //<AU>
	    //if (label.equals("<DE>")) {continue;}
		
	    line = line.substring(iii+1,jjj).trim(); // ... of <au> ... </au>

	    while (line.indexOf("  ")>-1) {line = line.replaceAll("  "," ");}
    	    line = line.trim();
		
	    if (line.equals("") || line==null) {System.out.println(tmpWords[fff]+" ))))))))))))))"); continue;}
	    if (!bc.tagHash.containsKey(label)) {System.out.println(tmpWords[fff]+" ))))))))))))))"); continue;}
		
	    C_INDEX = Integer.parseInt(String.valueOf(bc.tagHash.get(label)));
		
	    words1 = line.split(" ");
		
	    for(iii=0;iii<words1.length;iii++) {
	        if (deHash.containsKey(words1[iii])) {
		    jjj = Integer.parseInt(String.valueOf(deHash.get(words1[iii])));
		    deCntInCat[C_INDEX][jjj] +=1;
		}
	    }
	    //System.in.read();
	    //System.out.println("...6 ");
	}//for fff
	tmpWords = null;
	
	//System.out.println("tmdet/tmt");
	//scan file for marks M serving as delimiter, find all (Token_1 M Token_2),
	//build talbe: (t1, t2, m, cat, #)
	tmdet = new int[bc.T_SIZE+1][bc.T_SIZE+1][deV.size()][bc.C_SIZE];
	tmt = new int[bc.T_SIZE+1][bc.T_SIZE+1][bc.T_SIZE][bc.C_SIZE];
	for(iii=0;iii<bc.T_SIZE+1;iii++) {
	    for(jjj=0;jjj<bc.T_SIZE+1;jjj++) {
		for(fff=0;fff<deV.size();fff++) {for(ggg=0;ggg<bc.C_SIZE;ggg++) {tmdet[iii][jjj][fff][ggg] = 0;}}
		for(fff=0;fff<bc.T_SIZE;fff++) {for(ggg=0;ggg<bc.C_SIZE;ggg++) {tmt[iii][jjj][fff][ggg] = 0;}}
	    }
	}
	//scan file for marks M serving as delimiter, find all (cat_left M cat_right),
	//build talbe: (cat1, cat2, m, cat, #)
	cmdec = new int[bc.C_SIZE+1][bc.C_SIZE+1][deV.size()][bc.C_SIZE];
	for(iii=0;iii<bc.C_SIZE+1;iii++) {
	    for(jjj=0;jjj<bc.C_SIZE+1;jjj++) {
		for(fff=0;fff<deV.size();fff++) {for(ggg=0;ggg<bc.C_SIZE;ggg++) {cmdec[iii][jjj][fff][ggg] = 0;}}
	    }
	}
	
	fileStr1 = trainStr.replaceAll("___", " ");
	fileStr1 = fileStr1.trim();
	for(iii=0;iii<bc.csTag.length;iii++) {
	    fileStr1 = fileStr1.replaceAll("</"+bc.csTag[iii].substring(1),"");
	}
	while (fileStr1.indexOf("  ")>-1) {fileStr1 = fileStr1.replaceAll("  "," ");}
	words2 = fileStr1.split(" ");
	//System.out.println("----\n"+fileStr1);
	//fill tmdet and tmt, single <DE>-possible-mark only
	for(iii=0;iii<words2.length;iii++) {
	    //System.out.print(words2[iii]+" ");
	    
	    if (deHash.containsKey(words2[iii])) {
		fff = Integer.parseInt(String.valueOf(deHash.get(words2[iii])));
		//find category id, somewhere left of the current token
	        jjj = iii-1; //left token
	        while(jjj>=0 && !bc.tagHash.containsKey(words2[jjj])) {jjj--;}
	        catid = Integer.parseInt(String.valueOf(bc.tagHash.get(words2[jjj]))); //category id	
	        
		if (bc.csTag[catid].equals("<DE>")) {
		    // <AU> Smith <DE> , <TI> Algorithm
		    //find left token in data of another category
		    jjj = iii-1; //left token
		    while (jjj>-1 && !words2[jjj].equals("<DE>")) {jjj--;} //looking for <DE> tag
		    jjj--;//move to the word to the left of "<DE>"
		    if (jjj<0 || words2[jjj].equals("<REC>")) {leftTid  = bc.T_SIZE;}
		    else if (jjj==(iii-2)) {leftTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[jjj])))));}
		    else {leftTid = -1;}

		    if (leftTid>-1) {
			//find right token in data of another category
			jjj = iii+1; //right token
			while(jjj<words2.length && !bc.tagHash.containsKey(words2[jjj]) && !words2[jjj].equals("</REC>")) {jjj++;}
			jjj++; //move to the word to the right of the <CAT>
			if (jjj>=words2.length || words2[jjj].equals("<REC>") || words2[jjj].equals("</REC>")) { rightTid  = bc.T_SIZE;}
			else if (jjj==(iii+2)) {rightTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[jjj])))));}
			else {rightTid = -1;}
		    }
		    else {rightTid = -1;}
		}
		else { //category != <DE>, find left/right token in the same data segment, 
		    //<DE> mark should not be at boundary
		    //find left token
		    jjj = iii-1; //left token
		    if (jjj<0 || words2[jjj].equals("<REC>") || words2[jjj].equals("</REC>")) {leftTid = bc.T_SIZE;}
		    else if (bc.tagHash.containsKey(words2[jjj])) {
			System.out.println("<DE> word at boundary, check data!");
			leftTid = -1;
		    }
		    else {leftTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[jjj])))));}
		    //find right token 
		    jjj = iii+1; //right token
		    if (jjj>=words2.length || words2[jjj].equals("<REC>")) {rightTid = bc.T_SIZE;}
		    else if (bc.tagHash.containsKey(words2[jjj]) || words2[jjj].equals("</REC>")) {
			System.out.println("<DE> word at boundary, check data!");
			rightTid = -1;
		    }
		    else {rightTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[jjj])))));}
		}//else
		if (leftTid>=0 && rightTid >= 0) {tmdet[leftTid][rightTid][fff][catid]++;}
		
		//System.out.print(words2[iii-1]+" "+words2[iii]+" "+words2[iii+1]+" | ");
		//if (leftTid == bc.T_SIZE) {System.out.print("EMPTY ");}
		//else  {System.out.print(bc.tokenDic[leftTid]+" ");}
		//if (rightTid == bc.T_SIZE) {System.out.println("EMPTY \n");}
		//else  {System.out.println(bc.tokenDic[rightTid]+" \n");}
				    
	    }// if words2[iii] is a <DE> mark
	    //else words2[iii] is a non-<DE> word/mark, tmt
	    else if (!words2[iii].equals("<REC>") && !words2[iii].equals("</REC>") && !bc.tagHash.containsKey(words2[iii])) {
	        fff = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[iii])))));
		//find category id, somewhere left of the current token
	        jjj = iii-1; //left token
	        while(jjj>=0 && !bc.tagHash.containsKey(words2[jjj])) {jjj--;}
	        catid = Integer.parseInt(String.valueOf(bc.tagHash.get(words2[jjj]))); //category id
		jjj = iii-1; //left token
		if (jjj<0 || words2[jjj].equals("<REC>")) {leftTid = bc.T_SIZE;}
		else if (bc.tagHash.containsKey(words2[jjj])) {
		    jjj--;
		    if (jjj<0 || words2[jjj].equals("<REC>")) {leftTid = bc.T_SIZE;}
		    else {leftTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[jjj])))));}
		}
		else {leftTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[jjj])))));}
		
		jjj = iii+1; //right token
		if (jjj>=words2.length || words2[jjj].equals("</REC>")) {rightTid = bc.T_SIZE;}
		else if (bc.tagHash.containsKey(words2[jjj])) {
		    jjj++;
		    if (jjj>=words2.length || words2[jjj].equals("</REC>")) {rightTid = bc.T_SIZE;}
		    else {rightTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[jjj])))));}
		}
		else {
		    //System.out.println(words2[jjj]);
		    rightTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(words2[jjj])))));}
				
		tmt[leftTid][rightTid][fff][catid]++;
	    }
	}//for iii
	//fill cmdec
	for(iii=0;iii<words2.length;iii++) {
	    if (deHash.containsKey(words2[iii])) {
		fff = Integer.parseInt(String.valueOf(deHash.get(words2[iii])));
		//find category id, somewhere left of the current token
		jjj = iii-1; //left token
		while(jjj>=0 && !bc.tagHash.containsKey(words2[jjj])) {jjj--;}
		catid = Integer.parseInt(String.valueOf(bc.tagHash.get(words2[jjj]))); //category id	
	        
		if (bc.csTag[catid].equals("<DE>")) { //<au> smith ... <de> , <ti> algorithm ...
		    if (jjj==iii-1) { //<DE> ,
			jjj = jjj-1; //left word of <DE> 
			while (jjj>-1 && !words2[jjj].equals("<REC>") && !bc.tagHash.containsKey(words2[jjj])) {jjj--;} //looking for the cat tag
			if (jjj<0 || words2[jjj].equals("<REC>")) { leftTid  = bc.C_SIZE;}
			else {leftTid = Integer.parseInt(String.valueOf(bc.tagHash.get(words2[jjj])));}
			//find cat label for the right neighbor
			jjj = iii+1; //right token
			if (jjj>=words2.length || words2[jjj].equals("</REC>")) { rightTid  = bc.C_SIZE;}
			else if (!bc.tagHash.containsKey(words2[jjj])) { //multi-<DE> string, skip
			    rightTid = -1;
			}
			else {rightTid = Integer.parseInt(String.valueOf(bc.tagHash.get(words2[jjj])));}
		    }
		}
		else { //category != <DE>, find cat id of the left/right word in the (same) data segment
		    jjj = iii-1; //left token
		    if (jjj<0 || words2[jjj].equals("<REC>")) {leftTid = bc.C_SIZE;}
		    else if (bc.tagHash.containsKey(words2[jjj])) { //keep looking leftward in prev seg.
			System.out.println("<DE> word at boundary, check data!");
			leftTid = -1;
		    }
		    else {leftTid = catid;}
		    
		    jjj = iii+1; //right token
		    if (jjj>=words2.length || words2[jjj].equals("</REC>")) {rightTid = bc.C_SIZE;}
		    else if (bc.tagHash.containsKey(words2[jjj])) {
			System.out.println("<DE> word at boundary, check data!");
			rightTid = -1;
		    }
		    else {rightTid = catid;}
	 	}//else
		
		if (leftTid>-1 && rightTid>-1) {cmdec[leftTid][rightTid][fff][catid]++;}
		
		//System.out.print(words2[iii-1]+" "+words2[iii]+" "+words2[iii+1]+" | ");
		//if (leftTid == bc.C_SIZE) {System.out.print("EMPTY ");}
		//else  {System.out.print(bc.csTag[leftTid]+" ");}
		//if (rightTid == bc.C_SIZE) {System.out.println("EMPTY \n");}
		//else  {System.out.println(bc.csTag[rightTid]+" \n");}
	    }// if words2[iii] is a <DE> mark
	}//for iii
	//------------------
	cmmc.clear(); cmmcCnt.clear();
	tmmt.clear(); tmmtCnt.clear();
	//for(iii=0;iii<words2.length;iii++) {
	iii = 0;
	while (iii<words2.length) {
	    if (deHash.containsKey(words2[iii]) && (deHash.containsKey(words2[iii-1]) || deHash.containsKey(words2[iii+1]))) { //<DE> mark pair
		//looking to the left side
		jjj = iii-1; //left word
		while (jjj>-1 && !words2[jjj].equals("<REC>") && 
		       (bc.tagHash.containsKey(words2[jjj]) || deHash.containsKey(words2[jjj]))
		       ) {jjj--;} //looking for the 1st non-de-mark word on the left
		aaa = jjj;
		if (jjj<0 || words2[jjj].equals("<REC>")) { leftTid  = bc.C_SIZE;}
		else {
		    jjj--;
		    while (jjj>-1 && !words2[jjj].equals("<REC>") && !bc.tagHash.containsKey(words2[jjj])) {jjj--;} //looking for the catetory tag for the 1st non-de-mark word on the left
		    if (jjj<0 || words2[jjj].equals("<REC>")) { leftTid  = bc.C_SIZE;}
		    else {leftTid = Integer.parseInt(String.valueOf(bc.tagHash.get(words2[jjj])));}
		}
		//look to the right neighbor
		jjj = iii+1; //right token
		while(jjj<words2.length && !words2[jjj].equals("</REC>") &&
		      (bc.tagHash.containsKey(words2[jjj]) || deHash.containsKey(words2[jjj]))
		      ) {jjj++;} //looking for the 1st non-de-mark word on the right
		bbb = jjj;
		if (jjj>=words2.length || words2[jjj].equals("</REC>")) { rightTid  = bc.C_SIZE;}
		else {
		    jjj--;
		    while (jjj>-1 && !words2[jjj].equals("<REC>") && !bc.tagHash.containsKey(words2[jjj])) {jjj--;} //looking for the catetory tag for the 1st non-de-mark word on the right
		    if (jjj<0 || words2[jjj].equals("<REC>")) { rightTid  = bc.C_SIZE;}
		    else {rightTid = Integer.parseInt(String.valueOf(bc.tagHash.get(words2[jjj])));}
		}
		
		if (aaa>-1 && bbb<words2.length) {
		    found1 = false;
		    for(jjj=aaa+1;jjj<bbb;jjj++) {
		    	if (bc.tagHash.containsKey(words2[jjj])) {found1 = true;break;}
		    }
		    if ((found1 && bbb-aaa>3) || (!found1 && bbb-aaa>2)) {
		    	
			//find category id, somewhere left of the current token
			jjj = iii-1; //left token
			while(jjj>=0 && !bc.tagHash.containsKey(words2[jjj])) {jjj--;}
			catid = Integer.parseInt(String.valueOf(bc.tagHash.get(words2[jjj]))); //category id
			tmp10 = "(";
			//mm =-1; nn=0;
			for(jjj=aaa+1;jjj<bbb;jjj++) {
			    if (!bc.tagHash.containsKey(words2[jjj])) {
			    	tmp10 += words2[jjj]+" ";
				// mm++;
			    	//if (jjj==iii) {nn = mm;}
			    }
			}
			tmp10 = tmp10.trim()+") ";
			//tmp10 += "/"+String.valueOf(nn)+ " ";
			tmp11 = tmp10; //for tmmt
			
			if (leftTid!=bc.C_SIZE) {tmp10 += bc.csTag[leftTid];}
			else {tmp10 += "empty";}
			tmp10 += " ";
			if (rightTid!=bc.C_SIZE) {tmp10 += bc.csTag[rightTid];}
			else {tmp10 += "empty";}
			tmp10 += " "+bc.csTag[catid];
			
			found1 = false;
			for(jjj=0;jjj<cmmc.size();jjj++) {
			    if(String.valueOf(cmmc.elementAt(jjj)).equals(tmp10)) {
			    	cmmcCnt.set(jjj,String.valueOf(Integer.parseInt(String.valueOf(cmmcCnt.elementAt(jjj)))+1));
			    	found1 = true;
			    	break;
			    }
			}//for jjj update cmmcCnt
			if (!found1) {cmmc.add(tmp10);cmmcCnt.add("1");}
			
			if (leftTid!=bc.C_SIZE) {tmp11 += bc.getTokenType(words2[aaa]);}
			else {tmp11 += "empty";}
			tmp11 += " ";
			if (rightTid!=bc.C_SIZE) {tmp11 += bc.getTokenType(words2[bbb]);}
			else {tmp11 += "empty";}
			tmp11 += " "+bc.csTag[catid];
			
			found1 = false;
			for(jjj=0;jjj<tmmt.size();jjj++) {
			    if(String.valueOf(tmmt.elementAt(jjj)).equals(tmp11)) {
			    	tmmtCnt.set(jjj,String.valueOf(Integer.parseInt(String.valueOf(tmmtCnt.elementAt(jjj)))+1));
			    	found1 = true;
			    	break;
			    }
			}//for jjj update cmmcCnt
			if (!found1) {tmmt.add(tmp11);tmmtCnt.add("1");}
			
			//for(jjj=aaa;jjj<=bbb;jjj++) {System.out.print(words2[jjj]+" ");}
			//System.out.println(" | "+leftTid+" "+catid+" "+rightTid);
			//System.out.print(" | " + words2[iii]+" ");
			//if (leftTid!=bc.C_SIZE) {System.out.print(bc.csTag[leftTid]);}
			//else {System.out.print("empty");}
			//System.out.print(" "+bc.csTag[catid]+" ");
			//if (rightTid!=bc.C_SIZE) {System.out.println(bc.csTag[rightTid]);}
			//else {System.out.println("empty");}
			
		    }
		}// if bbb-aaa...
		iii = bbb;
	    }//if  words2[iii] is a <DE> mark
	    else {iii++;}
	}//for iii
	//for(jjj=0;jjj<cmmc.size();jjj++) {System.out.println(String.valueOf(cmmc.elementAt(jjj))+" "+String.valueOf(cmmcCnt.elementAt(jjj)));}
	/*
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    System.out.println("---------\n"+bc.csTag[iii]);
    	    for(jjj=0;jjj<deV.size();jjj++) {
    	    	System.out.println(String.valueOf(deV.elementAt(jjj)) + " " + String.valueOf(deCntV.elementAt(jjj)) + " " + String.valueOf(deCntInCat[iii].elementAt(jjj)));
            }
        }
	*/
    	return;
    }
    //#####################
    private void writeTrainingData(int argFolderID)
    {
	int zzz, nnn;
	try {
	    F2 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]);
	    F2.delete();
	    file2 = new RandomAccessFile(F2, "rw");
	    for(iii=0;iii<bc.C_SIZE;iii++) {file2.writeBytes("countC["+iii+"]="+countC[iii]+"\n");}
	    file2.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {file2.writeBytes("countW["+iii+"]="+wrd[iii].size()+"\n");}
	    file2.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {file2.writeBytes("countWW["+iii+"]="+ww[iii].size()+"\n");}
	    file2.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<tkn[iii].size();jjj++) {
		    file2.writeBytes("tkn["+iii+"]["+String.valueOf(tkn[iii].elementAt(jjj))+"]="+String.valueOf(tknC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file2.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<tt[iii].size();jjj++) {
		    file2.writeBytes("tt["+iii+"]["+String.valueOf(tt[iii].elementAt(jjj))+"]="+String.valueOf(ttC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file2.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<pos[iii].size();jjj++) {
		    file2.writeBytes("pos["+iii+"]["+String.valueOf(pos[iii].elementAt(jjj))+"]="+String.valueOf(posC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file2.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<pp[iii].size();jjj++) {
		    file2.writeBytes("pp["+iii+"]["+String.valueOf(pp[iii].elementAt(jjj))+"]="+String.valueOf(ppC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file2.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<wrd[iii].size();jjj++) {
		    file2.writeBytes("wrd["+iii+"]|"+String.valueOf(wrd[iii].elementAt(jjj))+"|="+String.valueOf(wrdC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file2.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<ww[iii].size();jjj++) {
		    file2.writeBytes("ww["+iii+"]|"+String.valueOf(ww[iii].elementAt(jjj))+"|="+String.valueOf(wwC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file2.writeBytes("\n");
	    
	    file2.writeBytes("deV_SIZE="+String.valueOf(deV.size())+"\n\n");
	    
	    for(jjj=0;jjj<deV.size();jjj++) {
		file2.writeBytes("de["+jjj+"]="+String.valueOf(deV.elementAt(jjj))+"\n");
	    }
	    file2.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<deV.size();jjj++) {
		    if (deCntInCat[iii][jjj]>0) {
			file2.writeBytes("dev["+iii+"]["+jjj+"]="+deCntInCat[iii][jjj]+"\n");
		    }
		}
	    }
	    file2.writeBytes("\n");
	    
	    for(iii=0;iii<bc.T_SIZE+1;iii++) {
		for(jjj=0;jjj<bc.T_SIZE+1;jjj++) {
		    for(fff=0;fff<deV.size();fff++) {
			for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			    if (tmdet[iii][jjj][fff][ggg]>0) {
				file2.writeBytes("tmdet[");
				if (iii==bc.T_SIZE) {file2.writeBytes(" ][");}
				else {file2.writeBytes(iii+"][");}
				if (jjj==bc.T_SIZE) {file2.writeBytes(" ][");}
				else {file2.writeBytes(jjj+"][");}
				file2.writeBytes(fff+"]["+ggg+"]="+tmdet[iii][jjj][fff][ggg]+"\n");
			    }
			}
		    }
		}
	    }
	    file2.writeBytes("\n");
	    for(iii=0;iii<bc.T_SIZE+1;iii++) {
		for(jjj=0;jjj<bc.T_SIZE+1;jjj++) {
		    for(fff=0;fff<bc.T_SIZE;fff++) {
			for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			    if (tmt[iii][jjj][fff][ggg]>0) {
				file2.writeBytes("tmt[");
				if (iii==bc.T_SIZE) {file2.writeBytes(" ][");}
				else {file2.writeBytes(iii+"][");}
				if (jjj==bc.T_SIZE) {file2.writeBytes(" ][");}
				else {file2.writeBytes(jjj+"][");}
				file2.writeBytes(fff+"]["+ggg+"]="+tmt[iii][jjj][fff][ggg]+"\n");
			    }
			}
		    }
		}
	    }
	    file2.writeBytes("\n");
	    for(iii=0;iii<bc.C_SIZE+1;iii++) {
		for(jjj=0;jjj<bc.C_SIZE+1;jjj++) {
		    for(fff=0;fff<deV.size();fff++) {
			for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			    if (cmdec[iii][jjj][fff][ggg]>0) {
				file2.writeBytes("cmdec[");
				if (iii==bc.C_SIZE) {file2.writeBytes(" ][");}
				else {file2.writeBytes(iii+"][");}
				if (jjj==bc.C_SIZE) {file2.writeBytes(" ][");}
				else {file2.writeBytes(jjj+"][");}
				file2.writeBytes(fff+"]["+ggg+"]="+cmdec[iii][jjj][fff][ggg]+"\n");
			    }
			}
		    }
		}
	    }
	    file2.writeBytes("\n");
	    for(jjj=0;jjj<cmmc.size();jjj++) {
		file2.writeBytes("cmmc "+String.valueOf(cmmc.elementAt(jjj))+" "+String.valueOf(cmmcCnt.elementAt(jjj))+"\n");
	    }//for jjj
	    file2.writeBytes("\n");
	    
	    for(jjj=0;jjj<tmmt.size();jjj++) {
		file2.writeBytes("tmmt "+String.valueOf(tmmt.elementAt(jjj))+" "+String.valueOf(tmmtCnt.elementAt(jjj))+"\n");
	    }//for jjj
	    file2.writeBytes("\n");
	    
	    //TOTALUNIQUEWORDS
	    wordList.clear();
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		found1 = false;
		for(jjj=0;jjj<wrd[iii].size();jjj++) {
		    tmp1 = String.valueOf(wrd[iii].elementAt(jjj));
		    found1 = false;
		    for(fff=0;fff<wordList.size();fff++) {
			tmp2 = String.valueOf(wordList.elementAt(fff));
			if (tmp1.equals(tmp2)) {
			    found1 = true;
			    break;
			}
		    }//for fff
		    if (!found1) {wordList.add(tmp1);}//System.out.println(wordList.size());}
		}
	    }
	    //System.out.println("iteration done" + wordList.size());
	    TOTALUNIQUEWORDS = wordList.size();
	    //System.out.println("assign done");
	    file2.writeBytes("totaluniquewords="+ TOTALUNIQUEWORDS +"\n");
	    //System.out.println("write file done");
	    file2.close();
	    wordList.clear();
	    //System.out.println("file2 done");
	    //file3 human readable file
	    F3 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_human");
	    F3.delete();
	    file3 = new RandomAccessFile(F3, "rw");
	    for(iii=0;iii<bc.C_SIZE;iii++) {file3.writeBytes("countC["+bc.csTag[iii]+"]="+countC[iii]+"\n");}
	    file3.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {file3.writeBytes("countW["+bc.csTag[iii]+"]="+wrd[iii].size()+"\n");}
	    file3.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {file3.writeBytes("countWW["+bc.csTag[iii]+"]="+ww[iii].size()+"\n");}
	    file3.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<tkn[iii].size();jjj++) {
		    file3.writeBytes("tkn["+bc.csTag[iii]+"]["+bc.tokenDic[Integer.parseInt(String.valueOf(tkn[iii].elementAt(jjj)))]+"]="+String.valueOf(tknC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file3.writeBytes("\n");
	    //System.out.println("file2 done");
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<tt[iii].size();jjj++) {
		    tmp1 = String.valueOf(tt[iii].elementAt(jjj));
		    //System.out.println("|"+tmp1+"|");
		    kk = tmp1.indexOf(" ");
		    tmp2 = tmp1.substring(kk+1);
		    tmp1 = tmp1.substring(0,kk);
		    file3.writeBytes("tt["+bc.csTag[iii]+"]["+bc.tokenDic[Integer.parseInt(tmp1)]+bc.tokenDic[Integer.parseInt(tmp2)]+"]="+String.valueOf(ttC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file3.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<pos[iii].size();jjj++) {
		    file3.writeBytes("pos["+bc.csTag[iii]+"]["+bc.posDic[Integer.parseInt(String.valueOf(pos[iii].elementAt(jjj)))]+"]="+String.valueOf(posC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file3.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<pp[iii].size();jjj++) {
		    tmp1 = String.valueOf(pp[iii].elementAt(jjj));
		    kk = tmp1.indexOf(" ");
		    tmp2 = tmp1.substring(kk+1);
		    tmp1 = tmp1.substring(0,kk);
		    file3.writeBytes("pp["+bc.csTag[iii]+"]["+bc.posDic[Integer.parseInt(tmp1)]+bc.posDic[Integer.parseInt(tmp2)]+"]="+String.valueOf(ppC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file3.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<wrd[iii].size();jjj++) {
		    file3.writeBytes("wrd["+bc.csTag[iii]+"]|"+String.valueOf(wrd[iii].elementAt(jjj))+"|="+String.valueOf(wrdC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file3.writeBytes("\n");

	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<ww[iii].size();jjj++) {
		    file3.writeBytes("ww["+bc.csTag[iii]+"]|"+String.valueOf(ww[iii].elementAt(jjj))+"|="+String.valueOf(wwC[iii].elementAt(jjj))+"\n");
		}
	    }
	    file3.writeBytes("\n");
	    
	    file3.writeBytes("deV_SIZE="+String.valueOf(deV.size())+"\n\n");
	    
	    for(jjj=0;jjj<deV.size();jjj++) {
		file3.writeBytes("de["+jjj+"]="+String.valueOf(deV.elementAt(jjj))+"\n");
	    }
	    file3.writeBytes("\n");
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		for(jjj=0;jjj<deV.size();jjj++) {
		    if (deCntInCat[iii][jjj]>0) {
			file3.writeBytes("dev["+bc.csTag[iii]+"]["+String.valueOf(deV.elementAt(jjj))+"]="+deCntInCat[iii][jjj]+"\n");
		    }
		}
	    }
	    file3.writeBytes("\n");
	    
	    for(iii=0;iii<bc.T_SIZE+1;iii++) {
		for(jjj=0;jjj<bc.T_SIZE+1;jjj++) {
		    for(fff=0;fff<deV.size();fff++) {
			for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			    if (tmdet[iii][jjj][fff][ggg]>0) {
				file3.writeBytes("tmdet[");
				if (iii==bc.T_SIZE) {file3.writeBytes(" ][");}
				else {file3.writeBytes(bc.tokenDic[iii]+"][");}
				if (jjj==bc.T_SIZE) {file3.writeBytes(" ][");}
				else {file3.writeBytes(bc.tokenDic[jjj]+"][");}
				file3.writeBytes(String.valueOf(deV.elementAt(fff))+"][");
				file3.writeBytes(bc.csTag[ggg]+"]="+tmdet[iii][jjj][fff][ggg]+"\n");
			    }
			}
		    }
		}
	    }
	    file3.writeBytes("\n");
	    for(iii=0;iii<bc.T_SIZE+1;iii++) {
		for(jjj=0;jjj<bc.T_SIZE+1;jjj++) {
		    for(fff=0;fff<bc.T_SIZE;fff++) {
			for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			    if (tmt[iii][jjj][fff][ggg]>0) {
				file3.writeBytes("tmt[");
				if (iii==bc.T_SIZE) {file3.writeBytes(" ][");}
				else {file3.writeBytes(bc.tokenDic[iii]+"][");}
				if (jjj==bc.T_SIZE) {file3.writeBytes(" ][");}
				else {file3.writeBytes(bc.tokenDic[jjj]+"][");}
				file3.writeBytes(bc.tokenDic[fff]+"][");
				file3.writeBytes(bc.csTag[ggg]+"]="+tmt[iii][jjj][fff][ggg]+"\n");
			    }
			}
		    }
		}
	    }
	    file3.writeBytes("\n");
	    for(iii=0;iii<bc.C_SIZE+1;iii++) {
		for(jjj=0;jjj<bc.C_SIZE+1;jjj++) {
		    for(fff=0;fff<deV.size();fff++) {
			for(ggg=0;ggg<bc.C_SIZE;ggg++) {
			    if (cmdec[iii][jjj][fff][ggg]>0) {
				file3.writeBytes("cmdec[");
				if (iii==bc.C_SIZE) {file3.writeBytes(" ][");}
				else {file3.writeBytes(bc.csTag[iii]+"][");}
				if (jjj==bc.C_SIZE) {file3.writeBytes(" ][");}
				else {file3.writeBytes(bc.csTag[jjj]+"][");}
				file3.writeBytes(String.valueOf(deV.elementAt(fff))+"][");
				file3.writeBytes(bc.csTag[ggg]+"]="+cmdec[iii][jjj][fff][ggg]+"\n");
			    }
			}
		    }
		}
	    }
	    file3.writeBytes("\n");
	    for(jjj=0;jjj<cmmc.size();jjj++) {
		file3.writeBytes("cmmc "+String.valueOf(cmmc.elementAt(jjj))+" "+String.valueOf(cmmcCnt.elementAt(jjj))+"\n");
	    }//for jjj
	    
	    file3.writeBytes("\n");
	    for(jjj=0;jjj<tmmt.size();jjj++) {
		file3.writeBytes("tmmt "+String.valueOf(tmmt.elementAt(jjj))+" "+String.valueOf(tmmtCnt.elementAt(jjj))+"\n");
	    }//for jjj
	    
	    file3.writeBytes("totaluniquewords="+ TOTALUNIQUEWORDS +"\n");
	    file3.close();
	}//try
	catch (java.lang.Exception e) {System.out.println(e.toString()+"..2");}
	
	return;
    }
    //####################
    public static void main(String[] args)
    {
    	segpTrain gf = new segpTrain(args[0], args[1], args[2]);//Dir name where the addTail files are
	gf.runTenFolder();
	/*
	  runTenFolder() ->
	  
	  readData() -> getFeatures()
	      
	      countDelimiter(); 
	      
	      writeTrainingData(runff);
	*/
	return;
    }
}
