/*
create training set for level-1 C4.5 decision tree
*/

import java.lang.*;
import java.io.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Date;
import montytagger.JMontyTagger;
//import java.text.DecimalFormat;
//##########################
class trainLevelOne
{ 
    private basicConcepts bc;
    private montytagger.JMontyTagger jmt;
    private double lemda = 0.5, dtmp1, dtmp2;
    private int[] countC;
    private String[][] wrd, ww;
    private int[][] wrdC, tknC, posC, wwC;
    private int[][][] ttC, ppC;
    private double[] smoothedDeW, probC, smoothedDeT, smoothedDeP;
    private int[][] countDe;
            
    //tmt[t1][t2][t][cat]
    private double[][][][] tmt;
    private double[][] tmpScore11, tmpScore12;
    
    private int[] features1, recCount;
    private String[] words1, punc, dataL, labelL, answerL, PU_LIST, deList, tmpWords, GL_LIST, JN_LIST, OR_LIST, OR2_LIST, FL_LIST, dataStr, fileNames;
    private char[] wtpL;
    private Vector pair1List, pair2List;
    
    private int lTid, rTid,  iii,jjj,fff,ggg, bbb;
    private int STARTSET, ENDSET, totalWordNum;
    private int ii, jj, kk, yy,zz, mm,  nn, wLen, countXX, countYY, countZZ, countVV, countUU;
    private String line, argTrainingDirName, argAbsDirName, fileStr1, DIC_AU, DIC_DA;
    private String trainStr, testStr, tmp1, tmp12;
    private File F1,F2, F3, F5, F6;
    private RandomAccessFile file1,file2, file5, file6;
    private boolean found1, hasWord;
    private Vector seg0;
    private Hashtable deHash;
    private Date sDate, eDate;
    private Vector[] cw, cwTF, pw, pwTF, wt, wtTF, wp, wpTF, tw, twTF;
    private filesFromDir ffd;
    private int[] wCountC;
    private int[][] wPosC;//, cPosC;
    //####################
    public trainLevelOne(String arg, String argStartID, String argEndID)
    {
	argTrainingDirName = arg;
	bc = new basicConcepts();
		
	try {
	    STARTSET = Integer.parseInt(argStartID);
	    ENDSET = Integer.parseInt(argEndID);
	}
	catch  (java.lang.Exception e) {System.out.println(e.toString()+"..startsetid"); STARTSET=0; ENDSET=0;}
	//-------------------
	jmt = new montytagger.JMontyTagger();
	
	countC = new int[bc.C_SIZE];
	//countW = new int[bc.C_SIZE];
	smoothedDeW = new double[bc.C_SIZE];
	smoothedDeT = new double[bc.C_SIZE];
	smoothedDeP = new double[bc.C_SIZE];
	probC = new double[bc.C_SIZE];
	tknC = new int[bc.C_SIZE][bc.T_SIZE];
	posC = new int[bc.C_SIZE][bc.P_SIZE];
	ttC = new int[bc.C_SIZE][bc.T_SIZE][bc.T_SIZE];
	ppC = new int[bc.C_SIZE][bc.P_SIZE][bc.P_SIZE];
	wrd = new String[bc.C_SIZE][];
	wrdC = new int[bc.C_SIZE][];
	ww = new String[bc.C_SIZE][];
	wwC = new int[bc.C_SIZE][];
	
	pair1List = new Vector();pair2List = new Vector();
	
	cw = new Vector[bc.C_SIZE]; cwTF = new Vector[bc.C_SIZE];
	pw = new Vector[bc.C_SIZE]; pwTF = new Vector[bc.C_SIZE];
	tw = new Vector[bc.C_SIZE]; twTF = new Vector[bc.C_SIZE];
	wp = new Vector[bc.C_SIZE]; wpTF = new Vector[bc.C_SIZE];
	wt = new Vector[bc.C_SIZE]; wtTF = new Vector[bc.C_SIZE];
	
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    cw[iii] = new Vector(); cwTF[iii] = new Vector();
	    pw[iii] = new Vector(); pwTF[iii] = new Vector();
	    tw[iii] = new Vector(); twTF[iii] = new Vector();
	    wp[iii] = new Vector(); wpTF[iii] = new Vector();
	    wt[iii] = new Vector(); wtTF[iii] = new Vector();
	}
	
	seg0 = new Vector();
		
	wCountC = new int[bc.C_SIZE];
	wPosC = new int[bc.C_SIZE][10];
	//cPosC = new int[bc.C_SIZE][10];
	
	punc = new String[bc.set2.length()];
	for(zz=0;zz<bc.set2.length();zz++) {punc[zz] = bc.set2.substring(zz,zz+1);}//System.out.println("|"+punc[zz]+"|");}
    }
    //###########
    int pp;
    private boolean isNumber(String arg)
    {
	for(pp=0;pp<punc.length;pp++) {
	    if (arg.equals(punc[pp])) {return true;}
	}
	try {
	    Integer.parseInt(arg);
	    return true;
	}
	catch(java.lang.Exception e) {return false;}
    }
    //#############
    //for each String, remove all tags, punctuation
    private String tmp9;
    private String removeTagPunc(String arg)
    {
    	tmp9 = arg;
    	tmp9 = tmp9.replaceAll("</[\\S]+>"," ");
    	tmp9 = tmp9.replaceAll("<[\\S]+>"," ");
    	tmp9 = tmp9.replaceAll("[^\\w ]+"," ");
    	while(tmp9.indexOf("  ")>-1) {tmp9 = tmp9.replaceAll("  ", " ");}
    	return tmp9.trim();    	
    }
    //#############
    String tmp13;
    int uu;
    private boolean isKeyWord(int argCID, String argWrd)
    {
	if (!bc.csTag[argCID].equals("<DA>") && !bc.csTag[argCID].equals("<AU>") && !bc.csTag[argCID].equals("<FL>") && !bc.csTag[argCID].equals("<GL>") && !bc.csTag[argCID].equals("<JN>") && !bc.csTag[argCID].equals("<OR>") && !bc.csTag[argCID].equals("<PU>")) {return false;}
	
	tmp13 = removeTagPunc(argWrd);
	if (tmp13.equals("") || tmp13==null) {return false;}
	tmp13 = " "+argWrd.toLowerCase().trim()+" ";
	
	if (bc.csTag[argCID].equals("<JN>")) {
	    for(uu=0;uu<JN_LIST.length;uu++) {
		if (tmp13.indexOf(JN_LIST[uu])>-1) {return true;}
	    }//for uu
	}
	else if (bc.csTag[argCID].equals("<FL>")) {
	    for(uu=0;uu<FL_LIST.length;uu++) {
		if (tmp13.indexOf(FL_LIST[uu])>-1) {return true;}
	    }//for uu
	}
	else if (bc.csTag[argCID].equals("<GL>")) {
	    for(uu=0;uu<GL_LIST.length;uu++) {
		if (GL_LIST[uu].equals(tmp13)) {return true;}
		//if (GL_LIST[uu].indexOf(tmp13)>-1) {return true;}
	    }//for uu
	}
	else if (bc.csTag[argCID].equals("<PU>")) {
	    for(uu=0;uu<PU_LIST.length;uu++) {
		if (PU_LIST[uu].indexOf(tmp13)>-1 || tmp13.indexOf(PU_LIST[uu])>-1) {return true;}
	    }//for uu
	}
	else if (bc.csTag[argCID].equals("<OR>")) {
	    found1 = false;
	    if (tmp13.trim().indexOf(" ")<0) {
	    	tmp13 = tmp13.trim();
		for(uu=0;uu<OR2_LIST.length;uu++) {
		    if (OR2_LIST[uu].equals(tmp13)) {return true;}
		}
	    }//if tmp13
	    else {
		for(uu=0;uu<OR_LIST.length;uu++) {
		    if (tmp13.indexOf(OR_LIST[uu])>-1) {return true;}
		}//for uu
	    }//else
	}
	else if (bc.csTag[argCID].equals("<DA>")) {
	    if (DIC_DA.indexOf(tmp13)>-1) {return true;}
	}//DATE
	else if (bc.csTag[argCID].equals("<AU>")) {
	    if (DIC_AU.indexOf(tmp13)>-1){return true;}
	}//au
	return false;
    }
    //##########
    private int findPairCount(int argCID, String argWW)
    {
	if (ww[argCID]==null) {return 0;}
	for(uu=0;uu<ww[argCID].length;uu++) {
	    if (ww[argCID][uu].equals(argWW)) {
		return wwC[argCID][uu];
	    }
	}
	return 0;
    }
    //##########
    private int findWordCount(int argCID, String argWrd)
    {
	if (wrd[argCID]==null) {return 0;}
	for(uu=0;uu<wrd[argCID].length;uu++) {
	    if (wrd[argCID][uu].equals(argWrd)) {
		return wrdC[argCID][uu];
	    }
	}
	return 0;
    }
    //##########
    private int findtwCount(int argCID, String argTW)
    {
	if (tw[argCID].size()==0) {return 0;}
	for(uu=0;uu<tw[argCID].size();uu++) {
	    if (String.valueOf(tw[argCID].elementAt(uu)).equals(argTW)) {
		return Integer.parseInt(String.valueOf(twTF[argCID].elementAt(uu)));
	    }
	}
	return 0;
    }
    //#########
    private int findwtCount(int argCID, String argWT)
    {
	if (wt[argCID].size()==0) {return 0;}
	for(uu=0;uu<wt[argCID].size();uu++) {
	    if (String.valueOf(wt[argCID].elementAt(uu)).equals(argWT)) {
		return Integer.parseInt(String.valueOf(wtTF[argCID].elementAt(uu)));
	    }
	}
	return 0;
    }
    //#########
    private int findpwCount(int argCID, String argPW)
    {
	if (pw[argCID].size()==0) {return 0;}
	for(uu=0;uu<pw[argCID].size();uu++) {
	    if (String.valueOf(pw[argCID].elementAt(uu)).equals(argPW)) {
		return Integer.parseInt(String.valueOf(pwTF[argCID].elementAt(uu)));
	    }
	}
	return 0;
    }
    //#########
    private int findwpCount(int argCID, String argWP)
    {
	if (wp[argCID].size()==0) {return 0;}
	for(uu=0;uu<wp[argCID].size();uu++) {
	    if (String.valueOf(wp[argCID].elementAt(uu)).equals(argWP)) {
		return Integer.parseInt(String.valueOf(wpTF[argCID].elementAt(uu)));
	    }
	}
	return 0;
    }
    //#########
    //P(a b c d) = P(a b)* P(b c)/P(b) * P(c d)/P(c), 16 combinations of P, S, D, N
    //wtpL = new char[seg0.size()]; //a word is found in all/some/none category?
    //getWTP();//mark all word pairs and single words
    //fill up tmpscore11
    String tmp8, tmp7, tmp11, tmp10;
    int wPos, ee;
    boolean iskwd;
    private void getStrScores(String argS, int argSegID) 
    {
	//System.out.println(argS);
	tmp8 = argS.trim();
	while (tmp8.indexOf("  ")>-1) {tmp8 = tmp8.replaceAll("  ", " ");}
	if (tmp8.equals("") || tmp8==null) {return;}
	
	//get pair/single/none word information, getWTP()
	pair1List.clear(); pair2List.clear();
	hasWord = false;
	
	words1 = tmp8.split(" ");
	wtpL = new char[words1.length];
	for(zz=0;zz<words1.length;zz++) {wtpL[zz] = 'N';}
	//test pair
	for(zz=0;zz<words1.length-1;zz++) {
	    if (deHash.containsKey(words1[zz]) || deHash.containsKey(words1[zz+1])) {continue;}//punc
	    if (isNumber(words1[zz]) || isNumber(words1[zz+1])) {continue;}
	    if (wtpL[zz]=='P' && wtpL[zz+1]=='P') {continue;}
	    tmp7 = words1[zz].toLowerCase()+" "+words1[zz+1].toLowerCase();
	    found1 = false;
	    for(mm=0;mm<bc.C_SIZE;mm++) {
		if (found1) {break;}
		if (ww[mm]==null) {continue;}
		for(ee=0;ee<ww[mm].length;ee++) {
		    if (ww[mm][ee].equals(tmp7) && wwC[mm][ee]>1) {
			wtpL[zz]='P'; wtpL[zz+1]='P';
			hasWord = true;
			found1 = true;
			pair1List.add(String.valueOf(zz)+" "+String.valueOf(zz+1));
			break;
		    }
		}//for
		if (!found1 && isKeyWord(mm, tmp7)) {
		    wtpL[zz]='P'; wtpL[zz+1]='P';
		    hasWord = true;
		    found1 = true;
		    pair1List.add(String.valueOf(zz)+" "+String.valueOf(zz+1));
		}
	    }
	}//for zz
	
	for(zz=0;zz<words1.length;zz++) {
	    if (deHash.containsKey(words1[zz])) {continue;}//punc
	    if (isNumber(words1[zz])) {continue;}
	    if (wtpL[zz]=='P' || wtpL[zz]=='S') {continue;}
	    tmp7 = words1[zz].toLowerCase();
	    found1 = false;
	    for(mm=0;mm<bc.C_SIZE;mm++) {
		if (found1) {break;}
		if (wrd[mm]==null) {continue;}
		for(ee=0;ee<wrd[mm].length;ee++) {
		    if (wrd[mm][ee].equals(tmp7)) {
			wtpL[zz]='S';
			hasWord = true;
			found1 = true;
			break;
		    }
		}//for
		if (!found1 && isKeyWord(mm, tmp7)) {
		    wtpL[zz]='S';
		    hasWord = true;
		    found1 = true;
		}
	    }
	}
	//not-found word pair
	for(zz=0;zz<words1.length-1;zz++) {
	    if (wtpL[zz]=='N' && wtpL[zz+1]=='N') {
		wtpL[zz]='D'; wtpL[zz+1]='D';
		pair2List.add(String.valueOf(zz)+" "+String.valueOf(zz+1));
	    }
	}//for zz
	
	//System.out.println("-------------");
	//for(zz=0;zz<words1.length;zz++) {System.out.print(zz+"/"+words1[zz]+"/"+wtpL[zz]+" ");}
	//System.out.println();
	//for(zz=0;zz<pair1List.size();zz++) {System.out.println(String.valueOf(pair1List.elementAt(zz)));}
	//System.out.println();
	
	//compute scores based on pure probability values
	for(zz=0;zz<words1.length;zz++) {
	    wPos = 0;
	    //--------------
	    if (wtpL[zz]=='P') {//word pair
		for(mm=0;mm<pair1List.size();mm++) {
		    tmp7 = String.valueOf(pair1List.elementAt(mm));
		    if (tmp7.startsWith(String.valueOf(zz)+" ")) {
			if (mm==0) {wPos = 1;}
			else {
			    tmp8 = String.valueOf(pair1List.elementAt(mm-1));
			    if (tmp8.endsWith(" "+String.valueOf(zz))) {wPos = 3;}
			    else {wPos = 1;}
			}
			break;
		    }//startswith
		    else if (tmp7.endsWith(" "+String.valueOf(zz))) {
			if (mm==0) {wPos = 2;}
			else {
			    tmp8 = String.valueOf(pair1List.elementAt(mm-1));
			    tmp8 = tmp8.substring(tmp8.indexOf(" ")+1);
			    tmp7 = tmp7.substring(0,tmp7.indexOf(" "));
			    
			    if (tmp8.equals(tmp7)) {wPos = 3;}
			    else {wPos = 2;}
			}
			break;
		    }//endswith
		}//for mm
		//System.out.println(zz+" "+words1[zz]+"/P "+wPos);
		
		if (wPos==1) { //p(wi, wi+1)
		    tmp7 = words1[zz].toLowerCase()+" "+words1[zz+1].toLowerCase();
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			iskwd = isKeyWord(mm, tmp7);
									
			countXX = findPairCount(mm, tmp7);
			if (countXX>0) {tmpScore11[argSegID][mm] *= (countXX+lemda) / smoothedDeW[mm];}
			else if (iskwd) {tmpScore11[argSegID][mm] *= (1+lemda) / smoothedDeW[mm];}
			else {
			    countYY = findWordCount(mm, words1[zz].toLowerCase());
			    countZZ = findWordCount(mm, words1[zz+1].toLowerCase());
			    tmpScore11[argSegID][mm] *= (countYY+lemda)/smoothedDeW[mm] * (countZZ+lemda)/smoothedDeW[mm];
			}			
		    }//for mm
		}//wpos==1
		else if (wPos==2) { //*1
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			tmpScore11[argSegID][mm] *= 1;
		    }
		}//wpos==2
		else if (wPos==3) { //p(wi-1, wi)/p(wi-1)
		    tmp7 = words1[zz-1].toLowerCase()+" "+words1[zz].toLowerCase();
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			iskwd = isKeyWord(mm, tmp7);
									
			countXX = findPairCount(mm, tmp7); //p(a b)
			countYY = findWordCount(mm, words1[zz-1].toLowerCase()); //p(a)
			if (countXX>0) {tmpScore11[argSegID][mm] *= ((countXX+lemda) / (countYY+lemda));} //p(a b)/p(a)
			else if (iskwd) {tmpScore11[argSegID][mm] *= (1+lemda) / smoothedDeW[mm];}
			else {
			    countZZ = findWordCount(mm, words1[zz].toLowerCase());
			    tmpScore11[argSegID][mm] *= (countYY+lemda)/smoothedDeW[mm] * (countZZ+lemda)/smoothedDeW[mm];
			}			
		    }//for mm
		}//wpos==3
	    }//'P'
	    //--------------
	    else if (wtpL[zz]=='S') {//single word
		//System.out.println(zz+" "+words1[zz]+"/S");
		tmp7 = words1[zz].toLowerCase();
		for(mm=0;mm<bc.C_SIZE;mm++) {
		    iskwd = isKeyWord(mm, tmp7);
		    		    		    			
		    countXX = findWordCount(mm, tmp7);
		    if (countXX>0) {tmpScore11[argSegID][mm] *= (countXX+lemda) / smoothedDeW[mm];}
		    else if (iskwd) {tmpScore11[argSegID][mm] *= (1+lemda) / smoothedDeW[mm];}
		    else {tmpScore11[argSegID][mm] *= lemda / smoothedDeW[mm];}
		}//for mm
	    }//'S'
	    //--------------
	    else if (wtpL[zz]=='N' && !hasWord) {//single unknown word, tmt also
		//System.out.println(zz+" "+words1[zz]+"/N");
		tmp7 = String.valueOf(bc.getTokenType(words1[zz]));
		nn = ((Integer)bc.tokenHash.get(tmp7)).intValue();
		
		//for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] *= ((tknC[mm][nn] + lemda) / smoothedDeT[mm]);}
		
		if (argSegID==0) {lTid = bc.T_SIZE;}
		else {
		    tmp10 = String.valueOf(seg0.elementAt(argSegID-1)).trim();
		    mm = tmp10.lastIndexOf(" ");
		    if (mm>-1) {tmp10 = tmp10.substring(mm+1);}
		    lTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(tmp10)))));
		}
		if (argSegID==seg0.size()-1) {rTid = bc.T_SIZE;}
		else {
		    tmp11 = String.valueOf(seg0.elementAt(argSegID+1)).trim();
		    mm = tmp11.indexOf(" ");
		    if (mm>-1) {tmp11 = tmp11.substring(0,mm);}
		    rTid = Integer.parseInt(String.valueOf(bc.tokenHash.get(String.valueOf(bc.getTokenType(tmp11)))));
		}
		for(mm=0;mm<bc.C_SIZE;mm++) {
		    tmpScore11[argSegID][mm] *= (tmt[lTid][rTid][nn][mm]+lemda);
		}//for mm
		
		//tmp7 = jmt.Tag(words1[zz]);
		//mm = tmp7.lastIndexOf("/");
		//if (mm>-1) {
		//    tmp7 = tmp7.substring(mm+1);//POS tag
		//    if (tmp7.length()>2) {tmp7 = tmp7.substring(0,2);}
		//    if (tmp7.startsWith("W")) {tmp7 = tmp7.substring(0,1);}
		//    for(mm=0;mm<bc.C_SIZE;mm++) {
		//	tmpScore11[argSegID][mm] *= ((posC[mm][((Integer)bc.posHash.get(tmp7)).intValue()]+lemda) / smoothedDeP[mm]);
			//}
		    //}
		
	    }//'N'
	    //--------------
	    else if (wtpL[zz]=='D' && !hasWord) {//unknown word pair
		for(mm=0;mm<pair2List.size();mm++) {
		    tmp7 = String.valueOf(pair2List.elementAt(mm));
		    if (tmp7.startsWith(String.valueOf(zz)+" ")) {
			if (mm==0) {wPos = 1;}
			else {
			    tmp8 = String.valueOf(pair2List.elementAt(mm-1));
			    if (tmp8.endsWith(" "+String.valueOf(zz))) {wPos = 3;}
			    else {wPos = 1;}
			}
			break;
		    }//startswith
		    else if (tmp7.endsWith(" "+String.valueOf(zz))) {
			if (mm==0) {wPos = 2;}
			else {
			    tmp8 = String.valueOf(pair2List.elementAt(mm-1));
			    tmp8 = tmp8.substring(tmp8.indexOf(" ")+1);
			    tmp7 = tmp7.substring(0,tmp7.indexOf(" "));
			    
			    if (tmp8.equals(tmp7)) {wPos = 3;}
			    else {wPos = 2;}
			}
			break;
		    }//endswith
		}//for mm
		//System.out.println(zz+" "+words1[zz]+"/D "+wPos);
		
		if (wPos==1) { //p(tokeni, tokeni+1)
		    tmp7 = String.valueOf(bc.getTokenType(words1[zz]));
		    ee = ((Integer)bc.tokenHash.get(tmp7)).intValue();
		    tmp8 = String.valueOf(bc.getTokenType(words1[zz+1]));
		    uu = ((Integer)bc.tokenHash.get(tmp7)).intValue();
		    
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			if (ttC[mm][ee][uu]>0) {
			    tmpScore11[argSegID][mm] *= ((ttC[mm][ee][uu] + lemda) / smoothedDeT[mm]);
			}
			else {
			    tmpScore11[argSegID][mm] *= (tknC[mm][ee] + lemda) / smoothedDeT[mm] * (tknC[mm][uu] + lemda) / smoothedDeT[mm];
			}
		    }//for mm
		    
		    tmp7 = jmt.Tag(words1[zz]);
		    if (tmp7.indexOf(" ")>-1) {tmp7 = tmp7.substring(0,tmp7.indexOf(" "));}
		    mm = tmp7.lastIndexOf("/");
		    if (mm>-1) {
			tmp7 = tmp7.substring(mm+1);//POS tag
			if (tmp7.length()>2) {tmp7 = tmp7.substring(0,2);}
			if (tmp7.startsWith("W")) {tmp7 = tmp7.substring(0,1);}
		    }
		    ee = ((Integer)bc.posHash.get(tmp7)).intValue();
		    
		    tmp8 = jmt.Tag(words1[zz+1]);
		    if (tmp8.indexOf(" ")>-1) {tmp8 = tmp8.substring(0,tmp8.indexOf(" "));}
		    mm = tmp8.lastIndexOf("/");
		    if (mm>-1) {
			tmp8 = tmp8.substring(mm+1);//POS tag
			if (tmp8.length()>2) {tmp8 = tmp8.substring(0,2);}
			if (tmp8.startsWith("W")) {tmp8 = tmp8.substring(0,1);}
		    }
		    uu = ((Integer)bc.posHash.get(tmp8)).intValue();
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			if (ppC[mm][ee][uu]>0) {
			    tmpScore11[argSegID][mm] *= ((ppC[mm][ee][uu]+lemda) / smoothedDeP[mm]);
			}
			else {
			    tmpScore11[argSegID][mm] *= (posC[mm][ee] + lemda) / smoothedDeP[mm] * (posC[mm][uu] + lemda) / smoothedDeP[mm];
			}
		    }
		}//wpos==1
		else if (wPos==2) { //*1
		    for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] *= 1;}
		}//wpos==2
		else if (wPos==3) { //p(wi-1, wi)/p(wi-1)
		    tmp7 = String.valueOf(bc.getTokenType(words1[zz-1]));
		    ee = ((Integer)bc.tokenHash.get(tmp7)).intValue();
		    tmp8 = String.valueOf(bc.getTokenType(words1[zz]));
		    uu = ((Integer)bc.tokenHash.get(tmp8)).intValue();
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			if (ttC[mm][ee][uu]>0) {
			    tmpScore11[argSegID][mm] *= ((ttC[mm][ee][uu] + lemda) / (tknC[mm][ee] + lemda));
			}
			else {
			    tmpScore11[argSegID][mm] *= (tknC[mm][ee] + lemda) / smoothedDeT[mm] * (tknC[mm][uu] + lemda) / smoothedDeT[mm];;
			}
		    }//for mm
		    
		    tmp7 = jmt.Tag(words1[zz-1]);
		    if (tmp7.indexOf(" ")>-1) {tmp7 = tmp7.substring(0,tmp7.indexOf(" "));}
		    mm = tmp7.lastIndexOf("/");
		    if (mm>-1) {
			tmp7 = tmp7.substring(mm+1);//POS tag
			if (tmp7.length()>2) {tmp7 = tmp7.substring(0,2);}
			if (tmp7.startsWith("W")) {tmp7 = tmp7.substring(0,1);}
		    }
		    ee = ((Integer)bc.posHash.get(tmp7)).intValue();
		    
		    tmp8 = jmt.Tag(words1[zz]);
		    if (tmp8.indexOf(" ")>-1) {tmp8 = tmp8.substring(0,tmp8.indexOf(" "));}
		    mm = tmp8.lastIndexOf("/");
		    if (mm>-1) {
			tmp8 = tmp8.substring(mm+1);//POS tag
			if (tmp8.length()>2) {tmp8 = tmp8.substring(0,2);}
			if (tmp8.startsWith("W")) {tmp8 = tmp8.substring(0,1);}
		    }
		    uu = ((Integer)bc.posHash.get(tmp8)).intValue();
		    for(mm=0;mm<bc.C_SIZE;mm++) {
			if (ppC[mm][ee][uu]>0) {
			    tmpScore11[argSegID][mm] *= ((ppC[mm][ee][uu] + lemda) / (posC[mm][ee] + lemda));
			}
			else {
			    tmpScore11[argSegID][mm] *= (posC[mm][ee] + lemda) / smoothedDeP[mm] * (posC[mm][uu] + lemda) / smoothedDeP[mm];;
			}
		    }
		}//wpos==3
	    }//'D'
	}//for zz
	if (argS.indexOf(" ")>-1) {for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] *= probC[mm];}}
	dtmp1 = 0;
	for(mm=0;mm<bc.C_SIZE;mm++) {dtmp1 += tmpScore11[argSegID][mm];}
	for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore11[argSegID][mm] = tmpScore11[argSegID][mm]/dtmp1;}
	//for(zz=0;zz<words1.length;zz++) {System.out.print(zz+"/"+words1[zz]+"/"+wtpL[zz]+" ");}
	//System.out.println();
	//for(zz=0;zz<pair1List.size();zz++) {System.out.println(String.valueOf(pair1List.elementAt(zz)));}
	//for(zz=0;zz<pair2List.size();zz++) {System.out.println(String.valueOf(pair2List.elementAt(zz)));}
	return;
    }
    //########
    private void readKeyWords()
    {
	String DIC_PU;
	DIC_AU = DIC_PU = DIC_DA = "";
	try {
	    F3 = new File(".", "dic_USALN");
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_AU += line.trim() +" ";}//while
	    file2.close();

	    F3 = new File(".", "dic_USAFN");
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_AU += line.trim() + " ";}//while
	    file2.close();
	    	    
	    F3 = new File(".", "dic_DBLPAU");
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_AU += line.trim() + " ";}//while
	    file2.close();
	    DIC_AU = " "+DIC_AU;
	    
	    F3 = new File(".", "dic_PU");
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_PU += line;}//while
	    file2.close();
	    PU_LIST = DIC_PU.split("  ");
	    for(ii=0;ii<PU_LIST.length;ii++) {
		PU_LIST[ii] = " "+removeTagPunc(PU_LIST[ii])+" ";
		
	    }
	    
	    F3 = new File(".", "dic_GL");
	    DIC_PU = "";
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_PU += line;}//while
	    file2.close();
	    DIC_PU = DIC_PU.trim();
	    GL_LIST = DIC_PU.split("  ");
	    for(ii=0;ii<GL_LIST.length;ii++) {GL_LIST[ii] = " " + GL_LIST[ii] + " ";}
	    
	    F3 = new File(".", "dic_JN");
	    DIC_PU = "";
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_PU += line;}//while
	    file2.close();
	    DIC_PU = DIC_PU.trim();
	    JN_LIST = DIC_PU.split(" ");
	    for(ii=0;ii<JN_LIST.length;ii++) {JN_LIST[ii] = " " + JN_LIST[ii] + " ";}
	    
	    F3 = new File(".", "dic_DA");
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_DA += line;}//while
	    file2.close();
	    
	    F3 = new File(".", "dic_OR");
	    DIC_PU = "";
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_PU += line;}//while
	    file2.close();
	    DIC_PU = DIC_PU.trim();
	    OR_LIST = DIC_PU.split("  ");
	    for(ii=0;ii<OR_LIST.length;ii++) {OR_LIST[ii] = " " + OR_LIST[ii] + " ";}
	    
	    F3 = new File(".", "dic_OR2");
	    DIC_PU = "";
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_PU += line;}//while
	    file2.close();
	    DIC_PU = DIC_PU.trim();
	    OR2_LIST = DIC_PU.split("  ");
	    //for(ii=0;ii<OR2_LIST.length;ii++) {System.out.println("_|"+OR_LIST[ii]+"|");}// = " "+removeTagPunc(OR_LIST[ii])+" ";}
	    
	    F3 = new File(".", "dic_FL");
	    DIC_PU = "";
	    file2 = new RandomAccessFile(F3,"r");
	    while((line = file2.readLine())!=null) {DIC_PU += line;}//while
	    file2.close();
	    DIC_PU = DIC_PU.trim();
	    FL_LIST = DIC_PU.split(" ");
	    for(ii=0;ii<FL_LIST.length;ii++) {FL_LIST[ii] = " "+FL_LIST[ii]+" ";}

	} catch (java.lang.Exception e) {System.out.println(e.toString()+"..zz");}  
	return;
    }
    //####################
    private void runTenFolder() 
    {
	int hhh, runff,rungg, uuu, vvv;
	sDate = new java.util.Date();

	try {
	    ffd = new filesFromDir();
	    ffd.set(argTrainingDirName,"_addTail");
	    if (ffd.findFiles() && ffd.fileList.size()>0) {
		F1 = new File(String.valueOf(ffd.fileList.elementAt(0)));
		argAbsDirName = F1.getPath(); 
		argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("/"));
		//argAbsDirName = argAbsDirName.substring(0,argAbsDirName.lastIndexOf("\\"));
	
		dataStr = new String[ffd.fileList.size()];
		recCount = new int[ffd.fileList.size()];
		fileNames = new String[ffd.fileList.size()];
		
		for(runff=0;runff<ffd.fileList.size();runff++) {
		    F1 = new File(String.valueOf(ffd.fileList.elementAt(runff)));
		    file1 = new RandomAccessFile(F1,"r");
		    		    
		    fileNames[runff] = F1.getPath();
		    //System.out.println(fileNames[runff]);
		    fileNames[runff] = fileNames[runff].substring(fileNames[runff].lastIndexOf("/")+1);
		    //fileNames[runff] = fileNames[runff].substring(fileNames[runff].lastIndexOf("\\")+1);
		    fileNames[runff] = fileNames[runff].substring(fileNames[runff].indexOf("clean_")+6, fileNames[runff].indexOf("_labeled"));
		    
		    recCount[runff] = 0; //# of rec <REC>
		    dataStr[runff] = "";
		    while ((line=file1.readLine())!=null) {
			if (!line.startsWith("<")) {continue;}
			dataStr[runff] += "___" + line.trim();
			if (line.equals("<REC>")) {recCount[runff]++;}
		    }
		    file1.close();
		}//for runff
	    } //if ffd
	    else {dataStr = null;}
	}
	catch (java.lang.Exception e) {System.out.println(e.toString());}
	
	//for(runff=0;runff<ffd.fileList.size();runff++) {System.out.println(dataStr[runff].length());}

	for(runff=STARTSET;runff<=ENDSET;runff++) { 
	    trainStr = testStr = ""; uuu = vvv = 0;
	    for(rungg=0;rungg<ffd.fileList.size();rungg++) {
	    	if (fileNames[rungg].equals(fileNames[runff])) {
		    testStr = dataStr[rungg]; uuu += recCount[rungg];
		} 
	    	else {trainStr += dataStr[rungg]; vvv+=recCount[rungg];}
	    }
	    
	    System.out.println(runff+". testing "+fileNames[runff]+ ": training_set:"+uuu+" testing_set:" + vvv);
	    
	    trainStr = trainStr.substring(3);
	    
	    readTrainingData(runff);
	    //System.out.println("training data read");
	    convert(runff);
	    //System.out.println("training data converted");
	    //readHybridData(runff);
	    //System.out.println("hybrid data read");
	    readTestData(runff);
	    //System.out.println("testing finished");
	}//for runff
	
	eDate = new java.util.Date();
	System.out.println(((eDate.getTime()-sDate.getTime())/1000/60)+"minutes");
	
	return;
    }
    //##################
    private void readTrainingData(int argFolderID)
    {
	totalWordNum = 0;
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    countC[iii] = 0; //countW[iii] = 0;
	    smoothedDeW[iii] = smoothedDeT[iii] = smoothedDeP[iii] = probC[iii] = 0;
	    cw[iii].clear(); cwTF[iii].clear(); pw[iii].clear(); pwTF[iii].clear();
	    wrd[iii] = null; wrdC[iii] = null; ww[iii] = null; wwC[iii] = null;
	    for(jjj=0;jjj<bc.T_SIZE;jjj++) {
		tknC[iii][jjj] = 0;
		for(fff=0;fff<bc.T_SIZE;fff++) {ttC[iii][jjj][fff] = 0;}
	    }
	    for(jjj=0;jjj<bc.P_SIZE;jjj++) {
		posC[iii][jjj] = 0;
		for(fff=0;fff<bc.P_SIZE;fff++) {ppC[iii][jjj][fff] = 0;}
	    }
	}//for iii
	
	try {
	    F2 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+ fileNames[argFolderID]);
	    file2 = new RandomAccessFile(F2, "r");
	    //read nbc from file
	    
	    while ((line=file2.readLine())!=null) {
		//System.out.println(line);
		if (line.startsWith("countC[")) {
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    countC[iii] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		}
		//else if (line.startsWith("countW[")) {
		//  iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		//  countW[iii] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		//}
		//else if (line.startsWith("countWW[")) {
		//  iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		//  countWW[iii] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		//}
		else if (line.startsWith("tkn[")) {
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    jjj = Integer.parseInt(line.substring(line.lastIndexOf("[")+1,line.lastIndexOf("]")));
		    tknC[iii][jjj] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		}
		else if (line.startsWith("pos[")) {
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    jjj = Integer.parseInt(line.substring(line.lastIndexOf("[")+1,line.lastIndexOf("]")));
		    posC[iii][jjj] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		}
		else if (line.startsWith("tt[")) {
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    tmp1 = line.substring(line.lastIndexOf("[")+1,line.lastIndexOf("]")); //tid1 tid2
		    jjj = Integer.parseInt(tmp1.substring(0,tmp1.indexOf(" ")));
		    fff = Integer.parseInt(tmp1.substring(tmp1.indexOf(" ")+1));
		    ttC[iii][jjj][fff] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		}
		else if (line.startsWith("pp[")) {
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    tmp1 = line.substring(line.lastIndexOf("[")+1,line.lastIndexOf("]")); //tid1 tid2
		    jjj = Integer.parseInt(tmp1.substring(0,tmp1.indexOf(" ")));
		    fff = Integer.parseInt(tmp1.substring(tmp1.indexOf(" ")+1));
		    ppC[iii][jjj][fff] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		}
		else if (line.startsWith("wrd[")) {
		    //[category]|word|=tf
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]"))); //category
		    cw[iii].add(line.substring(line.indexOf("|")+1, line.lastIndexOf("|")));
		    cwTF[iii].add(line.substring(line.lastIndexOf("=")+1)); //tf
		}
		else if (line.startsWith("ww[")) {
		    //[category]|w1 w2|=tf
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]"))); //category
		    pw[iii].add(line.substring(line.indexOf("|")+1, line.lastIndexOf("|")));
		    pwTF[iii].add(line.substring(line.lastIndexOf("=")+1)); //tf
		}
		//totaluniquewords=5265
		else if (line.startsWith("totaluniquewords=")) {
		    totalWordNum = Integer.parseInt(line.substring(line.lastIndexOf("=")+1));
		}
		else if (line.startsWith("deV_SIZE")) {
		    deList = new String[Integer.parseInt(line.substring(line.indexOf("=")+1).trim())];
		    //System.out.println("deList="+deList.length);
		    countDe = new int[bc.C_SIZE][deList.length];
		    for(ii=0;ii<bc.C_SIZE;ii++) {
			for(jj=0;jj<deList.length;jj++) {
			    countDe[ii][jj]=0;
			}
		    }
		    tmt = new double[bc.T_SIZE+1][bc.T_SIZE+1][bc.T_SIZE][bc.C_SIZE];
		    for(iii=0;iii<bc.T_SIZE+1;iii++) {
			for(jjj=0;jjj<bc.T_SIZE+1;jjj++) {
			    for(fff=0;fff<bc.T_SIZE;fff++) {for(ggg=0;ggg<bc.C_SIZE;ggg++) {tmt[iii][jjj][fff][ggg] = 0;}}
			}
		    }
		}
		else if (line.startsWith("de[")) {
		    ii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    deList[ii] = line.substring(line.indexOf("=")+1).trim();
		}
		else if (line.startsWith("dev[")) {//dev[cat][de_id]=cnt
		    ii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")));
		    kk = Integer.parseInt(line.substring(line.lastIndexOf("[")+1,line.lastIndexOf("]")));
		    jj = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		    countDe[ii][kk] = jj;
		}
		else if (line.startsWith("tmt[")) {//tmt[ ][42][3][8]=78.0
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    if (tmp1.equals(" ")) {ii = bc.T_SIZE;}
		    else {ii = Integer.parseInt(tmp1);}
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    if (tmp1.equals(" ")) {jj = bc.T_SIZE;}
		    else {jj = Integer.parseInt(tmp1);}
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    kk = Integer.parseInt(tmp1);
		    line = line.substring(nn+1);
		    
		    mm = line.indexOf("["); nn = line.indexOf("]");
		    tmp1 = line.substring(mm+1,nn);
		    yy = Integer.parseInt(tmp1);
		    line = line.substring(nn+1);
		    
		    tmt[ii][jj][kk][yy] = Integer.parseInt(line.substring(line.indexOf("=")+1));
		}
	    }//while
	    
	    file2.close();
	    dtmp1 = 0;
	    for(iii=0;iii<bc.C_SIZE;iii++) {dtmp1 += countC[iii];}
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		probC[iii] = (countC[iii]+lemda)/(dtmp1+lemda*bc.C_SIZE);
		//System.out.println("probC["+bc.csTag[iii]+"] "+probC[iii]);
	    }
	    //normalize probC
	    dtmp1 = 0;
	    for(iii=0;iii<bc.C_SIZE;iii++) {dtmp1 += probC[iii];}
	    for(iii=0;iii<bc.C_SIZE;iii++) {probC[iii] = probC[iii]/dtmp1;}
	    
	    for(iii=0;iii<bc.C_SIZE;iii++) {
		smoothedDeW[iii] = countC[iii] + lemda * totalWordNum;
		smoothedDeT[iii] = countC[iii] + lemda * totalWordNum;//bc.T_SIZE;
		smoothedDeP[iii] = countC[iii] + lemda * totalWordNum;//bc.P_SIZE;
		//System.out.println(bc.csTag[iii]+" "+smoothedDe[iii]);
	    }
	    
	    //System.out.println("nbc finished");
	    F2 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+ fileNames[argFolderID]+"_pos");
	    file2 = new RandomAccessFile(F2, "r");
	    //read nbc from file
	    while ((line=file2.readLine())!=null) {
		
		if (line.startsWith("countC[")) {
		    ii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")).trim());
		    wCountC[ii] = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		}
		else if (line.startsWith("wPosC[")) {//wPosC[cat][range]=cnt
		    ii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")).trim());
		    kk = Integer.parseInt(line.substring(line.lastIndexOf("[")+1,line.lastIndexOf("]")).trim());
		    jj = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		    wPosC[ii][kk] = jj;
		}
		/*
		else if (line.startsWith("cPosC[")) {//cPosC[cat][range]=cnt
		    ii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]")).trim());
		    kk = Integer.parseInt(line.substring(line.lastIndexOf("[")+1,line.lastIndexOf("]")).trim());
		    jj = Integer.parseInt(line.substring(line.indexOf("=")+1).trim());
		    cPosC[ii][kk] = jj;
		}
		*/
	    }
	    file2.close();
	    //System.out.println("pos finished");
	}//try
	catch (java.lang.Exception e) {System.out.println(e.toString()+"..2");}
	
	return;
    }
    //########
    private void convert(int argFolderID) //training data structure -> testing data structure
    {
	//countC[iii], deList, countDe, tmt
	//cw,cwTF-> wrd, wrdC for testing
	for(fff=0;fff<bc.C_SIZE;fff++) {
	    ggg = cw[fff].size();
	    if (ggg>0) {
		wrd[fff] = new String[ggg]; wrdC[fff] = new int[ggg];
		for(ggg=0;ggg<cw[fff].size();ggg++) {
		    wrd[fff][ggg] = String.valueOf(cw[fff].elementAt(ggg));
		    //if (cw2[fff][ggg].length()==1) {System.out.println(bc.csTag[fff]+" "+cw2[fff][ggg]);}
		    wrdC[fff][ggg] = Integer.parseInt(String.valueOf(cwTF[fff].elementAt(ggg)));
		    //cw2DF[fff][ggg] = Integer.parseInt(String.valueOf(cwDF[fff].elementAt(ggg)));
		}
	    }//if ggg>0
	    else {wrd[fff] = null; wrdC[fff] = null;}//cw2DF[fff] = null;}
	    cw[fff].clear();cwTF[fff].clear();//cwDF[fff].clear();
	}//for fff

	for(fff=0;fff<bc.C_SIZE;fff++) {
	    ggg = pw[fff].size();
	    if (ggg>0) {
		ww[fff] = new String[ggg]; wwC[fff] = new int[ggg]; 
		for(ggg=0;ggg<pw[fff].size();ggg++) {
		    ww[fff][ggg] = String.valueOf(pw[fff].elementAt(ggg));
		    wwC[fff][ggg] = Integer.parseInt(String.valueOf(pwTF[fff].elementAt(ggg)));
		}
	    }//if ggg>0
	    else {ww[fff] = null; wwC[fff] = null;}
	    pw[fff].clear();pwTF[fff].clear();
	}//for fff
	//System.out.println(deList.length);
	deHash = new Hashtable(deList.length);
	for(jj=0;jj<deList.length;jj++) {deHash.put(deList[jj],String.valueOf(jj));}
	
	return;
    }
    //#############
    /*
    private void readHybridData(int argFolderID) //tw,wt,pw,wp and counts
    {
	for(iii=0;iii<bc.C_SIZE;iii++) {
	    pw[iii].clear(); pwTF[iii].clear();
	    tw[iii].clear(); twTF[iii].clear();
	    wt[iii].clear(); wtTF[iii].clear();
	    wp[iii].clear(); wpTF[iii].clear();
	}//for iii
	
	try {
	    F2 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+ fileNames[argFolderID] + "_hybrid");
	    file2 = new RandomAccessFile(F2, "r");
	    	    
	    while ((line=file2.readLine())!=null) {
		//System.out.println(line);
		if (line.startsWith("wdtkn[")) {
		    //[category]|word tkn|tf
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]"))); //category
		    jjj = line.lastIndexOf("|");
		    wt[iii].add(line.substring(line.indexOf("|")+1, jjj));
		    wtTF[iii].add(line.substring(jjj+1)); //tf
		}
		else if (line.startsWith("tknwd[")) {
		    //[category]|tkn word|tf
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]"))); //category
		    jjj = line.lastIndexOf("|");
		    tw[iii].add(line.substring(line.indexOf("|")+1, jjj));
		    twTF[iii].add(line.substring(jjj+1)); //tf
		}
		else if (line.startsWith("wdpos[")) {
		    //[category]|word tkn|tf
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]"))); //category
		    jjj = line.lastIndexOf("|");
		    wp[iii].add(line.substring(line.indexOf("|")+1, jjj));
		    wpTF[iii].add(line.substring(jjj+1)); //tf
		}
		else if (line.startsWith("poswd[")) {
		    //[category]|word tkn|tf
		    iii = Integer.parseInt(line.substring(line.indexOf("[")+1,line.indexOf("]"))); //category
		    jjj = line.lastIndexOf("|");
		    pw[iii].add(line.substring(line.indexOf("|")+1, jjj));
		    pwTF[iii].add(line.substring(jjj+1)); //tf
		}
	    }//while
	    file2.close();
	    //System.out.println("pos finished");
	}//try
	catch (java.lang.Exception e) {System.out.println(e.toString()+"..2x");}
	//for(iii=0;iii<bc.C_SIZE;iii++) {System.out.println(pw[iii].size()+" "+ pwTF[iii].size()+" "+ tw[iii].size()+" "+ twTF[iii].size()+" "+ wt[iii].size()+" "+ wtTF[iii].size()+" "+ wp[iii].size()+" "+ wpTF[iii].size());}//for iii
	return;
    }
    */
    //########
    //get features from every record, save to _features file
    String rawData, tmp2, tmp3, tmp4, tmp5, tmp14;
    boolean found2;
    private void readTestData(int argFolderID)
    {
	try {
	    F5 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_train.arff");//training set J48
	    F5.delete();
	    file5 = new RandomAccessFile(F5, "rw");
	    file5.writeBytes("@relation "+fileNames[argFolderID]+"\n\n");
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {file5.writeBytes("@attribute "+jjj+" numeric\n");}
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {file5.writeBytes("@attribute "+(jjj+bc.C_SIZE)+" numeric\n");}
	    file5.writeBytes("@attribute Class {0,1,2,3,4,5,6,7,8,9,10}\n");
	    file5.writeBytes("\n@data\n");
	    /*
	    F6 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_train.arff.B");//training set J48
	    F6.delete();
	    file6 = new RandomAccessFile(F6, "rw");
	    file6.writeBytes("@relation "+fileNames[argFolderID]+"\n\n");
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {file6.writeBytes("@attribute "+jjj+" numeric\n");}
	    file6.writeBytes("@attribute Class {0,1,2,3,4,5,6,7,8,9,10}\n");
	    file6.writeBytes("\n@data\n");
	    */
	} catch (java.lang.Exception e) {System.out.println(e.toString()+"..#");}
    	
	trainStr += " ";
	iii = trainStr.indexOf("<REC>");
	jjj = trainStr.indexOf("</REC>");
	while(iii>-1 && jjj>iii) {
	    tmp1 = trainStr.substring(iii+5, jjj).trim();
	    while (tmp1.startsWith("___")) {tmp1 = tmp1.substring(3);}
	    while (tmp1.endsWith("___")) {tmp1 = tmp1.substring(0, tmp1.length()-3);}
	    trainStr = trainStr.substring(jjj+6);
	    //System.out.println(tmp1);
	    	    
	    tmp1 = tmp1.replaceAll("___", "");
	    for(iii=0;iii<bc.csTag.length;iii++) {tmp1 = tmp1.replaceAll("</"+bc.csTag[iii].substring(1)," ");}//for iii
	    
	    tmp2 = tmp1.trim(); //data w/ <cat_tag>
	    while (tmp2.indexOf("  ")>-1) {tmp2 = tmp2.replaceAll("  "," ");}
	    
	    for(iii=0;iii<bc.csTag.length;iii++) {tmp1 = tmp1.replaceAll(bc.csTag[iii]," ");}//for iii		
	    tmp1 = tmp1.trim(); //data w/o <cat_tag>
	    while (tmp1.indexOf("  ")>-1) {tmp1 = tmp1.replaceAll("  "," ");}
	    rawData = tmp1 +" ";//tmp2: <cat> seg <cat> seg <cat> seg tmp1: seg seg seg
	    dataL = tmp1.split(" "); //single words
	    
	    //creat labelL
	    words1 = tmp2.split(" ");
	    seg0.clear(); //tag list according to single words
	    for(iii=0;iii<words1.length;iii++) {
		if (bc.tagHash.containsKey(words1[iii])) {tmp3 = words1[iii];}
		else {seg0.add(tmp3);}
	    }
	    
	    tmpScore12 = new double[seg0.size()][bc.C_SIZE];
	    labelL = new String[seg0.size()]; //computed tag list according to single words
	    answerL = new String[seg0.size()]; //original tag list according to single words
	    for(iii=0;iii<seg0.size();iii++) {answerL[iii] = String.valueOf(seg0.elementAt(iii));}
	    //create initial segments, delimiter based on training results
	    seg0.clear();
	    iii = rawData.indexOf(" ");
	    tmp4 = "";
	    tmp5 = ""; //connectable elements
	    while (iii>0) {
		tmp2 = rawData.substring(0,iii).trim(); //left most string
		rawData = rawData.substring(iii+1);

		if (deHash.containsKey(tmp2)) {
		    if (!tmp5.equals("")) {
			seg0.add(tmp5.trim()); tmp5 = "";
		    }
		    tmp4 += tmp2+" ";
		}
		else {
		    if (!tmp4.equals("")) {seg0.add(tmp4.trim()); tmp4 = "";}
		    tmp5 += tmp2 + " ";
		}
		
		iii = rawData.indexOf(" ");
	    }//while (iii>0)
	    if (!tmp5.equals("")) {
		seg0.add(tmp5.trim()); tmp5 = "";
	    }
	    if (!tmp4.equals("")) {seg0.add(tmp4.trim()); tmp4 = "";}
	    
	    tmpScore11 = new double[seg0.size()][bc.C_SIZE];
	    for(iii=0;iii<seg0.size();iii++) {for(jjj=0;jjj<bc.C_SIZE;jjj++) {
		tmpScore11[iii][jjj] = 1;}
	    }//for iii
	    //System.out.println("---------------");
	    //for(iii=0;iii<seg0.size();iii++) {System.out.println("seg["+iii+"]="+String.valueOf(seg0.elementAt(iii)));}
	    //System.out.println("---------------\n");
	    
	    for(iii=0;iii<seg0.size();iii++) {
		tmp4 = String.valueOf(seg0.elementAt(iii));
		tmpWords = tmp4.split(" ");
		found2 = false;
		for(ggg=0;ggg<tmpWords.length;ggg++) {
		    if (deHash.containsKey(tmpWords[ggg])) {found2 = true;break;}
		}
		if (!found2) {
		    getStrScores(tmp4, iii);
		    //System.out.println("---------------\n"+String.valueOf(seg0.elementAt(iii)));
		    //for(jjj=0;jjj<bc.C_SIZE;jjj++) {System.out.println(bc.csTag[jjj]+" "+tmpScore11[iii][jjj]);}
		}
	    }//for iii
	    
	    getPairScores();//dataL, tmpScore10
	    
	    //assign labels to seg0
	    fff = -1;
	    for(iii=0;iii<seg0.size();iii++) {
		tmp4 = String.valueOf(seg0.elementAt(iii));
		tmpWords = tmp4.split(" ");
		for(jjj=0;jjj<tmpWords.length;jjj++) {
		    fff++;
		    labelL[iii] = answerL[fff];
		}
		
		found2 = false;
		for(ggg=0;ggg<tmpWords.length;ggg++) {
		    if (deHash.containsKey(tmpWords[ggg])) {found2 = true;break;}
		}
		if (!found2) {
		    try {
			for(jjj=0;jjj<bc.C_SIZE;jjj++) {file5.writeBytes(tmpScore11[iii][jjj]+",");}
			for(jjj=0;jjj<bc.C_SIZE;jjj++) {file5.writeBytes(tmpScore10[iii][jjj]+",");}
			file5.writeBytes(String.valueOf(bc.tagHash.get(labelL[iii]))+"\n");
			
			//for(jjj=0;jjj<bc.C_SIZE;jjj++) {file6.writeBytes(tmpScore11[iii][jjj]+",");}
			//file6.writeBytes(String.valueOf(bc.tagHash.get(labelL[iii]))+"\n");
		    } catch (java.lang.Exception e) {System.out.println(e.toString()+"..@");}
		}
		//else {//found SD segment
		//   try {file5.writeBytes("%\n");}
		//   catch (java.lang.Exception e) {System.out.println(e.toString()+"..@");}
		//}
		//System.out.println(labelL[iii]+" "+String.valueOf(seg0.elementAt(iii)));
	    }
	    //next record
	    iii = trainStr.indexOf("<REC>");
	    jjj = trainStr.indexOf("</REC>");
	}//while the whole file
	try {file5.close();
	//file6.close();
	} catch (java.lang.Exception e) {System.out.println(e.toString()+"..#");}
	
	//+++++++++++++++++++++++++++++++++
	try {
	    F5 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_test.arff");//testing set J48
	    F5.delete();
	    file5 = new RandomAccessFile(F5, "rw");
	    file5.writeBytes("@relation "+fileNames[argFolderID]+"\n\n");
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {file5.writeBytes("@attribute "+jjj+" numeric\n");}
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {file5.writeBytes("@attribute "+(jjj+bc.C_SIZE)+" numeric\n");}
	    file5.writeBytes("@attribute Class {0,1,2,3,4,5,6,7,8,9,10}\n");
	    file5.writeBytes("\n@data\n");
	    /*
	    F6 = new File(argAbsDirName,argTrainingDirName+"_nbc_"+fileNames[argFolderID]+"_test.arff.B");//testing set J48
	    F6.delete();
	    file6 = new RandomAccessFile(F6, "rw");
	    file6.writeBytes("@relation "+fileNames[argFolderID]+"\n\n");
	    for(jjj=0;jjj<bc.C_SIZE;jjj++) {file6.writeBytes("@attribute "+jjj+" numeric\n");}
	    file6.writeBytes("@attribute Class {0,1,2,3,4,5,6,7,8,9,10}\n");
	    file6.writeBytes("\n@data\n");
	    */
	} catch (java.lang.Exception e) {System.out.println(e.toString()+"..#");}
	
	testStr += " ";
	iii = testStr.indexOf("<REC>");
	jjj = testStr.indexOf("</REC>");
	while(iii>-1 && jjj>iii) {
	    tmp1 = testStr.substring(iii+5, jjj).trim();
	    while (tmp1.startsWith("___")) {tmp1 = tmp1.substring(3);}
	    while (tmp1.endsWith("___")) {tmp1 = tmp1.substring(0, tmp1.length()-3);}
	    testStr = testStr.substring(jjj+6);
	    //System.out.println(tmp1);
	    	    
	    tmp1 = tmp1.replaceAll("___", "");
	    for(iii=0;iii<bc.csTag.length;iii++) {tmp1 = tmp1.replaceAll("</"+bc.csTag[iii].substring(1)," ");}//for iii
	    
	    tmp2 = tmp1.trim(); //data w/ <cat_tag>
	    while (tmp2.indexOf("  ")>-1) {tmp2 = tmp2.replaceAll("  "," ");}
	    
	    for(iii=0;iii<bc.csTag.length;iii++) {tmp1 = tmp1.replaceAll(bc.csTag[iii]," ");}//for iii		
	    tmp1 = tmp1.trim(); //data w/o <cat_tag>
	    while (tmp1.indexOf("  ")>-1) {tmp1 = tmp1.replaceAll("  "," ");}
	    rawData = tmp1 +" ";//tmp2: <cat> seg <cat> seg <cat> seg tmp1: seg seg seg
	    dataL = tmp1.split(" "); //single words
	    
	    //creat labelL
	    words1 = tmp2.split(" ");
	    seg0.clear(); //tag list according to single words
	    for(iii=0;iii<words1.length;iii++) {
		if (bc.tagHash.containsKey(words1[iii])) {tmp3 = words1[iii];}
		else {seg0.add(tmp3);}
	    }
	    
	    tmpScore12 = new double[seg0.size()][bc.C_SIZE];
	    labelL = new String[seg0.size()]; //computed tag list according to single words
	    answerL = new String[seg0.size()]; //original tag list according to single words
	    for(iii=0;iii<seg0.size();iii++) {answerL[iii] = String.valueOf(seg0.elementAt(iii));}
	    //create initial segments, delimiter based on training results
	    seg0.clear();
	    iii = rawData.indexOf(" ");
	    tmp4 = "";
	    tmp5 = ""; //connectable elements
	    while (iii>0) {
		tmp2 = rawData.substring(0,iii).trim(); //left most string
		rawData = rawData.substring(iii+1);

		if (deHash.containsKey(tmp2)) {
		    if (!tmp5.equals("")) {
			seg0.add(tmp5.trim()); tmp5 = "";
		    }
		    tmp4 += tmp2+" ";
		}
		else {
		    if (!tmp4.equals("")) {seg0.add(tmp4.trim()); tmp4 = "";}
		    tmp5 += tmp2 + " ";
		}
		
		iii = rawData.indexOf(" ");
	    }//while (iii>0)
	    if (!tmp5.equals("")) {
		seg0.add(tmp5.trim()); tmp5 = "";
	    }
	    if (!tmp4.equals("")) {seg0.add(tmp4.trim()); tmp4 = "";}
	    
	    tmpScore11 = new double[seg0.size()][bc.C_SIZE];
	    for(iii=0;iii<seg0.size();iii++) {for(jjj=0;jjj<bc.C_SIZE;jjj++) {
		tmpScore11[iii][jjj] = 1;}
	    }//for iii
	    //System.out.println("---------------");
	    //for(iii=0;iii<seg0.size();iii++) {System.out.println("seg["+iii+"]="+String.valueOf(seg0.elementAt(iii)));}
	    //System.out.println("---------------\n");
	    
	    for(iii=0;iii<seg0.size();iii++) {
		tmp4 = String.valueOf(seg0.elementAt(iii));
		tmpWords = tmp4.split(" ");
		found2 = false;
		for(ggg=0;ggg<tmpWords.length;ggg++) {
		    if (deHash.containsKey(tmpWords[ggg])) {found2 = true;break;}
		}
		if (!found2) {
		    getStrScores(tmp4, iii);
		    //System.out.println("---------------\n"+String.valueOf(seg0.elementAt(iii)));
		    //for(jjj=0;jjj<bc.C_SIZE;jjj++) {System.out.println(bc.csTag[jjj]+" "+tmpScore11[iii][jjj]);}
		}
	    }//for iii
	    
	    getPairScores();//dataL, tmpScore10
	    
	    //assign labels to seg0
	    fff = -1;
	    for(iii=0;iii<seg0.size();iii++) {
		tmp4 = String.valueOf(seg0.elementAt(iii));
		tmpWords = tmp4.split(" ");
		for(jjj=0;jjj<tmpWords.length;jjj++) {
		    fff++;
		    labelL[iii] = answerL[fff];
		}
		
		found2 = false;
		for(ggg=0;ggg<tmpWords.length;ggg++) {
		    if (deHash.containsKey(tmpWords[ggg])) {found2 = true;break;}
		}
		
		if (!found2) {
		    try {
			for(jjj=0;jjj<bc.C_SIZE;jjj++) {file5.writeBytes(tmpScore11[iii][jjj]+",");}
			for(jjj=0;jjj<bc.C_SIZE;jjj++) {file5.writeBytes(tmpScore10[iii][jjj]+",");}
			file5.writeBytes(String.valueOf(bc.tagHash.get(labelL[iii]))+"\n");
			
			//for(jjj=0;jjj<bc.C_SIZE;jjj++) {file6.writeBytes(tmpScore11[iii][jjj]+",");}
			//file6.writeBytes(String.valueOf(bc.tagHash.get(labelL[iii]))+"\n");
		    } catch (java.lang.Exception e) {System.out.println(e.toString()+"..@");}
		    //System.out.println(labelL[iii]+" "+String.valueOf(seg0.elementAt(iii)));
		}
		//else {//found SD segment
		//  try {file5.writeBytes("%\n");}
		//  catch (java.lang.Exception e) {System.out.println(e.toString()+"..@");}
		//}
	    }
	    //next record
	    iii = testStr.indexOf("<REC>");
	    jjj = testStr.indexOf("</REC>");
	}//while the whole file
	try {file5.close();
	//file6.close();
	} catch (java.lang.Exception e) {System.out.println(e.toString()+"..#");}
	return;
    }
    //###############
    private double[][] tmpScore10;
    private double score1, score2;
    private int qq;
    private void getPairScores() 
    {
	tmpScore10 = new double[seg0.size()][bc.C_SIZE]; //getPairScores
	for(zz=0;zz<seg0.size();zz++) {for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore10[zz][mm] = 1;}}
	
	wLen = dataL.length;
	
	nn = 0; //length in tokens before current token, indexOf current token in the record
	/*
	for(zz=0;zz<seg0.size();zz++) {
	    tmp4 = String.valueOf(seg0.elementAt(zz));
	    tmpWords = tmp4.split(" ");
	    found2 = false;
	    for(mm=0;mm<tmpWords.length;mm++) {
		if (deHash.containsKey(tmpWords[mm])) {found2 = true;break;}
	    }
	    
	    if (!found2) {
		dtmp1 = 0;
		for(mm=0;mm<tmpWords.length;mm++) {dtmp1 += (1+mm);}
		dtmp1 = (nn+ dtmp1*1.0 / tmpWords.length) /wLen;
				    
		if (dtmp1<0.1) {yy = 0;}
		else if (dtmp1>=0.1 && dtmp1<0.2) {yy = 1;}
		else if (dtmp1>=0.2 && dtmp1<0.3) {yy = 2;}
		else if (dtmp1>=0.3 && dtmp1<0.4) {yy = 3;}
		else if (dtmp1>=0.4 && dtmp1<0.5) {yy = 4;}
		else if (dtmp1>=0.5 && dtmp1<0.6) {yy = 5;}
		else if (dtmp1>=0.6 && dtmp1<0.7) {yy = 6;}
		else if (dtmp1>=0.7 && dtmp1<0.8) {yy = 7;}
		else if (dtmp1>=0.8 && dtmp1<0.9) {yy = 8;}
		else if (dtmp1>=0.9 && dtmp1<=1.0) {yy = 9;}
		//System.out.println("----------\n"+dataL[zz]);
		for(qq=0;qq<bc.C_SIZE;qq++) {
		    if (wCountC[qq]==0) {tmpScore10[zz][qq] *= java.lang.Math.pow(lemda, 10);}
		    else if (wPosC[qq][yy]>0) {tmpScore10[zz][qq] *= wPosC[qq][yy] * 1.0 / wCountC[qq];}
		    else {tmpScore10[zz][qq] *= lemda / wCountC[qq];}
		    //System.out.println(bc.csTag[qq]+" "+tmpScore10[zz][qq]);
		}//for qq
		tmpScore10[zz][Integer.parseInt(String.valueOf(bc.tagHash.get("<DE>")))] = java.lang.Math.pow(lemda, 10);
	    }//if !found2
	    nn += tmpWords.length;
	}//for zz
	*/
	for(zz=0;zz<seg0.size();zz++) {
	    tmp4 = String.valueOf(seg0.elementAt(zz));
	    tmpWords = tmp4.split(" ");
	    found2 = false;
	    for(mm=0;mm<tmpWords.length;mm++) {
		if (deHash.containsKey(tmpWords[mm])) {found2 = true;break;}
	    }
	    
	    if (!found2) {
		for(mm=0;mm<tmpWords.length;mm++) {
		    dtmp1 = (nn+ mm)*1.0 /wLen;
		
		    if (dtmp1<0.1) {yy = 0;}
		    else if (dtmp1>=0.1 && dtmp1<0.2) {yy = 1;}
		    else if (dtmp1>=0.2 && dtmp1<0.3) {yy = 2;}
		    else if (dtmp1>=0.3 && dtmp1<0.4) {yy = 3;}
		    else if (dtmp1>=0.4 && dtmp1<0.5) {yy = 4;}
		    else if (dtmp1>=0.5 && dtmp1<0.6) {yy = 5;}
		    else if (dtmp1>=0.6 && dtmp1<0.7) {yy = 6;}
		    else if (dtmp1>=0.7 && dtmp1<0.8) {yy = 7;}
		    else if (dtmp1>=0.8 && dtmp1<0.9) {yy = 8;}
		    else if (dtmp1>=0.9 && dtmp1<=1.0) {yy = 9;}
		    
		    for(qq=0;qq<bc.C_SIZE;qq++) {
			if (wCountC[qq]==0) {tmpScore10[zz][qq] *= java.lang.Math.pow(lemda, 4);}
			else if (wPosC[qq][yy]>0) {tmpScore10[zz][qq] *= wPosC[qq][yy] * 1.0 / wCountC[qq];}
			else {tmpScore10[zz][qq] *= lemda / wCountC[qq];}
		    }//for qq
		}//for mm
	    }// if !found2
	    nn += tmpWords.length;
	}//for zz
	//normalization		
	for(zz=0;zz<seg0.size();zz++) {
	    //if (deHash.containsKey(dataL[zz])) {continue;}
	    tmp4 = String.valueOf(seg0.elementAt(zz));
	    tmpWords = tmp4.split(" ");
	    found2 = false;
	    for(mm=0;mm<tmpWords.length;mm++) {
		if (deHash.containsKey(tmpWords[mm])) {found2 = true;break;}
	    }
	    if (!found2) {
		dtmp1 = 0;
		for(mm=0;mm<bc.C_SIZE;mm++) {dtmp1 += tmpScore10[zz][mm];}//for mm
		for(mm=0;mm<bc.C_SIZE;mm++) {tmpScore10[zz][mm] = tmpScore10[zz][mm] / dtmp1;}
	    }
	}
	
	return;
    }
    //#############
    public static void main(String[] args)
    {
    	trainLevelOne gf = new trainLevelOne(args[0], args[1], args[2]);//Dir name where the addTail files are
	gf.readKeyWords();
	gf.runTenFolder();
	/*
	  runTenFolder() ->
	  
	  readTrainingData(runff);
	      
	  convert(); 
	  readHybridData(runff);
	  readTestData(runff) ->

	          getStrScores() -> removeTagPunc()
		  getPairScores()
		  
		  
     	 */
	return;
    }
}
